'            Analyseur de reseau    (sous licence GPL version 2)
' 
' Programme pour afficher les mesures d'impedances faites avec le programme zmeasure
' les fichiers avec l'extension s1p ou s2p sont ouverts et les courbes sont affichees
' La frequence doit etre en Hz, le module de s11 ou s22 doit etre en dB, la phase doit etre en degres
' Le nombre de points de mesure doit etre de: 51 ou 101 ou 201 ou 401 ou 801

screen 20,8,3' ecran 1024*768 ,8bits par pixel (mode palette), 3 plans
dim shared time1 as double
dim shared time2 as double
dim shared time3 as double
dim shared time4 as double
dim shared time5 as double
dim shared time6 as double
dim shared usberror as integer=0
dim shared duree as double
dim shared x as integer
dim shared xx as integer
dim shared y as integer
dim shared l as string 'pour la lecture clavier
dim shared abort as integer=0
dim shared aw as string
dim shared fdd as double=0
dim shared lu as integer=0
dim shared z1 as integer=0
dim shared z2 as integer=0
dim shared z3 as integer=0
dim shared z4 as integer=0
dim shared z5 as integer=0
dim shared z6 as integer=0
dim shared z7 as integer=0
dim shared z8 as integer=0
dim shared z9 as integer=0
dim shared z10 as integer=0
dim shared z11 as integer=0
dim shared z12 as integer=0
dim shared z13 as integer=0
dim shared z14 as integer=0
dim shared z15 as integer=0
dim shared z16 as integer=0
dim shared z17 as integer=0
dim shared z18 as integer=0
dim shared z22 as integer=0
dim shared z23 as integer=0
dim shared z24 as integer=0
dim shared z25 as integer=0
dim shared largeur as double=800 'choisir un nombre qui se divise par (nb-1)
dim shared hauteur as double=690 'choisir un nombre qui se divise par 10
dim shared bor as integer=3
dim shared couleur as integer
dim shared c15 as integer :c15=&hfce4b8 
dim shared c14 as integer :c14=&hfcfc54
dim shared c13 as integer :c13=&hfc54fc
dim shared c12 as integer :c12=&hfc5454
dim shared c10 as integer :c10=&h54fc54
dim shared c9 as integer  :c9=&h707070 
dim shared c3 as integer :c3=&h00a8a8
dim shared c1 as integer :c1=&h909000 
dim shared c2 as integer :c2=&h00a800
dim shared c0 as integer :c0=&h000000
dim shared c6 as integer :c6=&ha85400 
dim shared c7 as integer :c7=&h004c4c
dim shared c8 as integer :c8=&h545454
dim shared cursor1 as integer =100
dim shared cursor2 as integer =200
dim shared cur1 as integer =0
dim shared cur2 as integer =0
dim shared curseur1 as integer =100
dim shared curseur2 as integer =200
dim shared tupeu as integer
dim shared bouton as integer
dim shared wheel as integer=0
dim shared cleft as integer=0
dim shared cright as integer=0
setmouse 1,1,1
dim shared x1 as integer
dim shared y1 as integer
dim shared za as integer
dim shared pi as double =3.1415926
dim shared angle as double =0
dim shared wc1 as double
dim shared zc1 as double
dim shared fstart as double =14300000
dim shared fstop as double =14370000
dim shared linlog as integer=0
dim shared compteur as integer=0
dim shared fago as integer=1 'pour reperer le premier passage dans la boucle d'aquisition
dim shared f as integer
dim shared plouf as ubyte
dim shared p as short =0
dim shared pp as short =0
dim shared freq(805) as double 'tableau des frequences de mesure
dim shared nb as short =401
dim shared li(60) as ubyte
dim shared N1 as uinteger
dim shared N2 as uinteger
dim shared va as byte =1
dim shared i as integer=0
dim shared k as integer
dim shared flag1 as ubyte
dim shared flag2 as ubyte
dim shared bid as ubyte
dim shared t as integer
dim shared M(930) as integer
dim shared Q(930) as integer
dim shared fx as ubyte
dim shared za1 as double
dim shared za2 as double
dim shared za3 as double
dim shared wa1 as double
dim shared wa2 as double
dim shared wa3 as double
dim shared wa6 as double
dim shared za6 as double
dim shared dfi as double
dim shared w33(803) as double 'tableau de mesure de la fonction de transfert
dim shared z33(803) as double
dim shared a1(803) as double 'tableau du module des gains
dim shared t1(803) as double 'tableau des phases ou delay
dim shared aa(803) as double 'tableau des gains pour la memoire(apres calcul sur m1 et m2
dim shared tt(803) as double 'tableau des phases(delay) pour la memoire
dim shared M1(803) as double 'copie des courbes en memoire
dim shared M2(803) as double
dim shared Ma1 as double
dim shared Ma2 as double
dim shared zt(803) as double 'tableau pour la normalization
dim shared wt(803) as double
dim shared M1L(803) as double 'copie des courbes en memoire avec la correction de longueur
dim shared M2L(803) as double
dim shared z3L(803) as double 'fonction de transfert avec correction de longeur
dim shared w3L(803) as double 
dim shared wnd(803) as double 'fonction de transfert avec correction de calibration
dim shared znd(803) as double
dim shared wndd(803) as double 'fonction de transfert de la memoire avec correction de calibration
dim shared zndd(803) as double
dim shared wed3 as double
dim shared zed3 as double
dim shared ha(803) as double
dim shared hb(803) as double
dim shared ti as integer =0
dim shared ga as single
dim shared ma as single
dim shared gaa as single
dim shared maa as single
dim shared maax(11) as double 
dim shared miin(11) as double  'valeur des minimun suivant le mode ti (parametre affiche 1)
dim shared maxa(11) as double  'valeur des maximun suivant le mode ti (parametre affiche 2)
dim shared mina(11) as double 
dim shared oaf as single 
dim shared oaf2 as single
dim shared oap as single
dim shared oap2 as single
dim shared oaa as single
dim shared oaa2 as single
dim shared ouf as single
dim shared ouf2 as single
dim shared oup as single
dim shared oup2 as single
dim shared pmax as integer=0
dim shared limite as integer=0
dim shared stab as integer=7 'temps de stabilisation du filtre analogique (mesur en echantillon)
dim shared nbsamp as integer=6 '(nbsamp+1)=nombre d'echantillons utilises pour la mesure apres stabilisation
'dim shared eff as integer=1 'eff=0 si on a une courbe complete a l'ecran
dim shared complet as integer=0 'complet=1 a la fin d'une aquisition
dim shared cente as integer=0 'cente=1 quand on rentre la frequence avec center et span
dim shared disp as integer=0 'si disp=1 on est en mode affichage sans balayage
dim shared sort as integer=0 'pour dire qu'il faut sortir
dim shared ef as integer=0 'si ef=1 il faut effacer l'ecran
dim shared copynom as string
copynom="noname"
dim shared cal as integer=0 '1=en attente de enter pour demarrer la calibration open
                            '2=en cours de calibration open
                            '3=en attente de enter pour demarer la calibration short
                            '4=calibration short en cours
                            '5=en attente de enter pour demarer la calibration reference load
                            '6=calibration reference load en cours
                            '7=calibration terminee
                            '8=warning, la calibration n'est plus valable                            
dim shared newcal as integer=0 'newcal=1 indique qu'il faut refaire la calibration
dim shared m1m2 as integer=0 'm1m2=1 indique qu'il y a des donnees valide en memoire
dim shared ap as integer=0 'aperture pour le group delay
dim shared pa as integer=0 'pour avoir une copie de ap
dim shared center as double=20000000 'frequence centrale
dim shared span as double=40000000
dim shared refresh as integer=0
dim shared titre as string
titre="               Title                    "
dim shared rep as integer
dim shared repl as integer
dim shared lon as double=0 'longueur en metres pour la correction de longueur
dim shared dis as integer=0 'pour choisir les courbes a afficher
dim shared ali as integer=3
dim shared bobo as string
dim shared ff as integer
dim shared gggain as single=1
dim shared ggain as single=1
dim shared ppphas as single=0
dim shared pphas as single=0
dim shared ccclock as integer=150000000
dim shared cclock as integer=150000000
dim shared defogain as single=1 'gain par defaut entre l'entree A et l'entree R
dim shared defophas as single=0 'dephasage par defaut entre l'entree A et l'entree R
dim shared defoclk as integer=150000000 'frequence de l'horloge (par defaut) en Hz
dim shared defousbcom as short=3    'adresse par defaut pour le port COM (USB)
dim shared comport as short=3   'adresse du port COM (USB)
dim shared deforef as single=50 'resistance de calibration, par defaut
dim shared defolref as single=0 'self en serie avec la resistance de calibration
dim shared defocref as single=0 'capa en parallele avec la resistance de calibration
dim shared acquii as integer=0
dim shared zz1 as integer=0
dim shared zz2 as integer=0
dim shared zz3 as integer=0
dim shared zz4 as integer=0
dim shared zz5 as integer=0
dim shared zz6 as integer=0
dim shared zz7 as integer=0
dim shared zz as integer=0
dim shared num as integer=0
dim shared erreur1 as integer=0
dim shared erreur2 as integer=0
dim shared erreur3 as integer=0
dim shared erreur4 as integer=0
dim shared erreur5 as integer=0
dim shared zzz5 as integer=0
dim shared round as single=0
dim shared stoprequest as integer=0
dim shared zq22 as integer=0
dim shared sauvpo as integer
dim shared choi as integer
dim shared bmpecri as integer
dim shared xistdja as string
dim shared ss2112 as integer=0 'ss2112=0 pour dire que c'est s21 que l'on va ecrire
'im shared copynom as string
dim shared mxxx as string
dim shared dxxx as string
dim shared axx as single
dim shared t1xx as single
dim shared axxx as single
dim shared bibi as string
dim shared taille as integer
dim shared baba as string
dim shared kk as string
kk=""
dim shared c as string*1
dim shared esclam as integer
dim shared diese as integer
dim shared done as integer
dim shared acqi as integer
dim shared ll as integer
dim shared frec as double
dim shared nbb as integer
'dim shared freqq as string
dim shared freqqs as string
dim shared ms11s as string
dim shared as11s as string
dim shared ms22s as string
dim shared as22s as string
dim shared zute1 as double
dim shared zute2 as double
dim shared time9 as double
dim shared fff as integer
dim shared ff2 as integer
dim shared copinom as string
dim shared startorder as string
dim shared received as string
dim shared ressu as string
dim shared relax as integer
dim shared freqecri as string
dim shared freqstring as string
dim shared ii as integer
dim shared zut3 as double
dim shared zut4 as double
dim shared roue as integer
dim shared rouee as integer
dim shared roue1 as integer
dim shared roue2 as integer
dim shared roue3 as integer
dim shared roue4 as integer
dim shared roue5 as integer
dim shared roue6 as integer
dim shared roue7 as integer
dim shared roue8 as integer
dim shared roue9 as integer
dim shared roue12 as integer
dim shared roue14 as integer
dim shared kz as double
dim shared fb as integer
dim shared pixel as ubyte
dim shared ligne as string
dim shared unbyte as ubyte
dim shared deuxbyte as ushort
dim shared quatrebyte as uinteger
dim shared red as ubyte
dim shared green as ubyte
dim shared blue as ubyte
dim shared zero as ubyte
dim shared rouge as uinteger
dim shared vert as uinteger
dim shared bleu as uinteger

dim shared rel as double
dim shared ima as double
dim shared rell as double
dim shared imaa as double
dim shared mods11 as double
dim shared omega as double
dim shared wnn as double
dim shared znn as double
dim shared wnnn as double
dim shared znnn as double
dim shared denom as double
dim shared lref as single
dim shared cref as single
dim shared refr as single
dim shared zrefr as double
dim shared zrefi as double
dim shared w24 as double
dim shared ws(802) as double
'dim shared z24 as double
dim shared zs(802) as double
dim shared w13 as double
dim shared wo(802) as double
'dim shared z13 as double
dim shared zo(802) as double
dim shared zr(802) as double
dim shared w41 as double
dim shared zh41 as double
dim shared w32 as double
dim shared wr(802) as double
dim shared zh32 as double
dim shared twnd as double
dim shared zh13 as double
dim shared zh24 as double
dim shared wn as double
dim shared zn as double
dim shared wd as double
dim shared zd as double
dim shared wdd as double
dim shared zdd as double
dim shared twndd as double
dim shared wh3 as double
dim shared zh3 as double
dim shared wnnx as double
dim shared znnx as double
dim shared rrrefr as single
dim shared lllref as single
dim shared cccref as single
dim shared zhnd as double
dim shared whnd as double
dim shared ss1122 as integer
dim shared bubu as string
dim shared xist1 as string
dim shared xist2 as string
dim shared xist3 as string
dim shared haa as double
dim shared hbb as double
dim shared correction1 as double
dim shared correction2 as double
dim shared usbcom as short
dim shared usbcomm as short
dim shared portcom as string
dim shared n as integer
dim shared d as integer
dim shared dlist(300) as string
dim shared h as integer
dim shared ta as integer
dim shared v as integer
dim shared j as integer
dim shared sxp as integer  ' =1 si fichier s1p , =2 si fichier s2p
dim shared freqq(802) as double 'tableau des frequences
dim shared ms11(802) as single 'module de s11 en dB
dim shared as11(802) as single 'phase de s11 en degres
dim shared ms22(802) as single 'module de s22 en dB
dim shared as22(802) as single 'phase de s22 en degres
'dim shared freqqs as string
dim shared angls11 as double
dim shared rs11 as double
dim shared is11 as double
dim shared denomina as double
dim shared mods22 as double
dim shared angls22 as double
dim shared rs22 as double
dim shared is22 as double
dim shared flin200 as double
dim shared flog200 as double
dim shared ss11s22 as integer
dim shared pagelength as integer
dim shared nbofline as integer
dim shared yy as integer
dim shared yysaved as integer
dim shared selectarea as integer=0
dim shared curhaut as integer
dim shared curbas as integer
dim shared bouge as integer=0
dim shared yclic as integer=0
dim shared newh as integer
dim shared hclic as integer

declare sub dessin1
declare sub dessin2
declare sub verif
declare sub markers
declare sub calcul
declare sub acqui
declare sub frequence
declare sub menu
declare sub z2sub
declare sub z4sub
declare sub z14sub
declare sub z6sub
declare sub help
declare sub adjust
declare sub savefile
declare sub efasse
declare sub ecribmp
declare sub s2ps21
declare sub s2ps12
declare sub s21s12
declare sub s2112dja
declare sub wheel1
declare sub wheel2
declare sub lserie
declare sub lpara
declare sub cpara
declare sub cserie
declare sub s1p
declare sub s11s22
declare sub s2ps22
declare sub s2ps11
declare sub s1122dja
declare sub setport

palette 0,&h00,&h00,&h00
palette 1,&h90,&h90,&h00
palette 2,&h00,&ha8,&h00
palette 3,&h00,&ha8,&ha8
palette 4,&h00,&h00,&h00
palette 5,&h00,&h00,&h00
palette 6,&ha8,&h54,&h00
palette 7,&h00,&h4c,&h4c
palette 8,&h54,&h54,&h54
palette 9,&h70,&h70,&h70
palette 10,&h54,&hfc,&h54
palette 11,&h00,&h00,&h00
palette 12,&hfc,&h54,&h54
palette 13,&hfc,&h54,&hfc
palette 14,&hfc,&hfc,&h54
palette 15,&hfc,&he4,&hb8
palette 16,&ha0,&ha0,&ha0


bobo="configu"
rep=fix((largeur+bor)/8)+1

sub dessin1
    
screenset 2,0
dim nbdec as integer
dim hi as integer
pa=0 :if ti=2 then pa=ap '
line (bor,bor)-(bor+largeur,bor+hauteur),7,bf
couleur=8
if linlog=0 then
    for i=0 to 10  'quadrillage lineaire sur l'axe des frequences
        couleur=8 :if i=5 then couleur=9
        line (bor+largeur*i/10,bor)-(bor+largeur*i/10,bor+hauteur),couleur
    next i
else    'quadrillage logarithmique sur l'axe des frequences
    dim frec as double
    dim xxx as double
    nbdec=fix(log(fstart)/log(10))
    hi=fix(fstart/(10^nbdec))+1
    frec=hi*10^nbdec
    while (((hi)*(10^nbdec))<=fstop)
        while((hi<10) and ((hi)*(10^nbdec))<=fstop)
            frec=hi*(10^nbdec)
            xxx=log(frec/fstart)*largeur/log(fstop/fstart)
            if hi=1 then couleur=9
            line(bor+xxx,bor)-(bor+xxx,bor+hauteur),couleur
            if hi=1 then couleur=8
            hi=hi+1
        wend
        nbdec=nbdec+1
        hi=1
    wend
end if
if ti<10 or ti>10 then
    for i=0 to 10     'quadrillage lineaire en ordonne
        couleur=8 :if i=5 then couleur=9
        line (bor,bor+hauteur*i/10)-(bor+largeur,bor+hauteur*i/10),couleur
    next i
end if
if ti=10 then
    dim meex as double
    dim yyy as double
    dim miink as double
    dim maaxk as double
    miink=1000*miin(ti)
    maaxk=1000*maax(ti)
    nbdec=fix(log(miink)/log(10))
    hi=fix(miink/(10^nbdec))+1
    meex=hi*10^nbdec
    while (((hi)*(10^nbdec))<=maaxk)
        while((hi<10) and ((hi)*(10^nbdec))<=maaxk)
            meex=hi*(10^nbdec)
            yyy=log(meex/miink)*hauteur/log(maaxk/miink)
            if hi=1 then couleur=9
            line(bor,bor+hauteur-yyy)-(bor+largeur,bor+hauteur-yyy),couleur
            if hi=1 then couleur=8
            hi=hi+1
        wend
        nbdec=nbdec+1
        hi=1
    wend
end if

    screenset 1,0
    screencopy 2,1
end sub    

sub dessin2
    line (bor+cursor1,bor)-(bor+cursor1,hauteur+bor),12 'dessin des curseurs
    line (bor+cursor2,bor)-(bor+cursor2,hauteur+bor),13
    if ti<10 then
        ga=hauteur/(maax(ti)-miin(ti))
        ma=hauteur*maax(ti)/(maax(ti)-miin(ti))
    end if
    if ti=10 then
        ga=hauteur/(log(maax(ti))/log(10)-log(miin(ti))/log(10))
        ma=hauteur*log(maax(ti))/log(10)/(log(maax(ti))/log(10)-log(miin(ti))/log(10))
    end if
    limite=pmax
    if complet=1 then limite=nb-1
    if ef=1 then limite=0
    for i=1 to limite  'dessin de la courbe jusqu'a pmax ou nb-1
        if ti<10 then
            oaf=bor+ma-ga*a1(i-1)
            oaf2=bor+ma-ga*a1(i)
        else
            oaf=bor+ma-ga*log(a1(i-1))/log(10)
            oaf2=bor+ma-ga*log(a1(i))/log(10)
        end if
        if oaf2>hauteur+bor then oaf2=hauteur+bor
        if oaf>hauteur+bor then oaf=hauteur+bor
        if oaf2<bor then oaf2=bor
        if oaf<bor then oaf=bor
        line(bor+largeur*(i-1)/(nb-1),oaf)-(bor+largeur*(i)/(nb-1),oaf2),14
        if ss11s22=3 then
        'if (dis=2 or dis=3) and m1m2=1 and complet=1 then
            if ti<10 then
                ouf=bor+ma-ga*aa(i-1)
                ouf2=bor+ma-ga*aa(i)
            else
                ouf=bor+ma-ga*log(aa(i-1))/log(10)
                ouf2=bor+ma-ga*log(aa(i))/log(10)
            end if                
            if ouf2>hauteur+bor then ouf2=hauteur+bor
            if ouf>hauteur+bor then ouf=hauteur+bor
            if ouf2<bor then ouf2=bor
            if ouf<bor then ouf=bor
            line(bor+largeur*(i-1)/(nb-1),ouf)-(bor+largeur*i/(nb-1),ouf2),1
        end if
    next i
 
maa=bor+hauteur*maxa(ti)/(maxa(ti)-mina(ti))
gaa=hauteur/(maxa(ti)-mina(ti))
for i=1+pa/2 to limite-pa/2  'dessin de la courbe jusqu'a pmax ou nb-1
    oap=maa-gaa*t1(i-1)
    oap2=maa-gaa*t1(i)    
    if oap2>hauteur+bor then oap2=hauteur+bor
    if oap>hauteur+bor then oap=hauteur+bor
    if oap2<bor then oap2=bor
    if oap<bor then oap=bor 
    if (dis=0 or dis=2)  then    
        line(bor+largeur*(i-1)/(nb-1),oap)-(bor+largeur*(i)/(nb-1),oap2),10
    end if
    if dis=0 and ss11s22=3 then
    'if dis=2 and m1m2=1 and complet=1 then
        oup=maa-gaa*tt(i-1)
        oup2=maa-gaa*tt(i)
        if oup2>hauteur+bor then oup2=hauteur+bor
        if oup>hauteur+bor then oup=hauteur+bor
        if oup2<bor then oup2=bor
        if oup<bor then oup=bor
        line(bor+largeur*(i-1)/(nb-1),oup)-(bor+largeur*(i)/(nb-1),oup2),2
    end if
next i

screenset 0,0
screencopy 1,0
end sub


sub verif
    if miin(ti)>maax(ti) then
        erreur1=1
        locate 31,rep+2 :color 0,6
        print "        Error          "
        locate 32,rep+2 
        print "  Gain Max < Gain Min  "
        color 15,0
    else
        erreur1=0
    end if
    if mina(ti)>maxa(ti) then
        erreur2=1
        locate 31,rep+2 :color 0,6
        print "        Error          "
        locate 32,rep+2
        if ti=2 then print " Delay Max < Delay Min "
        if ti=0 or ti=1 then print " Phase Max < Phase Min "
        color 15,0
    else
        erreur2=0
    end if
    if fstart>fstop then
        erreur3=1
        locate 31,rep+2 :color 0,6
        print "        Error          "
        locate 32,rep+2
        print "  Freq Max < Freq Min  "
        color 15,0
    else
        erreur3=0
    end if
    if cente=1 then
        if center+span/2>99999999.98 then
            erreur4=1
            locate 31,rep+2 :color 0,6
            print "        Error          "
            locate 32,rep+2
            print "Center + Span/2 > 99MHz"
            color 15,0
        else
            erreur4=0
        end if
        if (center-span/2)<10 then
            erreur5=1
            locate 31,rep+2 :color 0,6
            print "        Error          "
            locate 32,rep+2
            print "Center - Span/2 < 20Hz "
            color 15,0
        else
            erreur5=0
        end if
    end if
    
    if cente=1 then
        fstart=center-span/2
        fstop=center+span/2
    end if
    if cente=0 then
        center=(fstart+fstop)/2
        span=fstop-fstart
    end if
end sub



sub markers
    screenset 1,0
    tupeu=1
    if (complet=1) or (pmax>=curseur1) then
        locate 45,13 :print using "#########.##";freq(curseur1)
        locate 45,29
        if a1(curseur1)<9999999999.98 and a1(curseur1)>-999999999.98 then
            print using "##########.###";a1(curseur1)
        else
            print "  overscale  "
        end if
        locate 45,46
        if t1(curseur1)<9999999999.98 and t1(curseur1)>-999999999.98 then
            print using "##########.###";t1(curseur1)
        else
            print "  overscale  "
        end if
    else
        locate 45,13 :print "            "
        locate 45,29 :print "              "
        locate 45,46 :print "             "
    end if
    if (complet=1) or (pmax>=curseur2) then
        locate 46,13 :print using "#########.##";freq(curseur2)
        locate 46,29
        if a1(curseur2)<9999999999.98 and a1(curseur2)>-999999999.98 then
            print using "##########.###";a1(curseur2)
        else
            print "  overscale  "
        end if
        locate 46,46
        if t1(curseur2)<9999999999.98 and t1(curseur2)>-999999999.98 then
            print using "##########.###";t1(curseur2)
        else
            print "  overscale  "
        end if        
    else
        locate 46,13 :print "            "
        locate 46,29 :print "              "
        locate 46,46 :print "             "
    end if
    if (complet=1) or ((pmax>=curseur1) and (pmax>=curseur2)) then
        locate 47,13 :print using "#########.##";freq(curseur2)-freq(curseur1)
        locate 47,29
        if a1(curseur2)-a1(curseur1)<9999999999.98 and a1(curseur2)-a1(curseur1)>-999999999.98 then
            print using "##########.###";a1(curseur2)-a1(curseur1)
        else
            print  "  overscale  "
        end if
        locate 47,46
        if t1(curseur2)-t1(curseur1)<9999999999.98 and t1(curseur2)-t1(curseur1)>-999999999.98 then
            print using "##########.###";t1(curseur2)-t1(curseur1)
        else
            print "  overscale  "
        end if
    else
        locate 47,13 :print "            "
        locate 47,29 :print "              "
        locate 47,46 :print "             "
    end if
end sub


sub calcul

    if z33(p)=0 then z33(p)=1E-32
    if w33(p)=0 then w33(p)=1E-32
    if M1(p)=0 then M1(p)=1E-32
    if M2(p)=0 then M2(p)=1E-32

    if linlog=1 then
        omega=2*pi*freq(p)
    else
        omega=2*pi*freq(p)
    end if


    if (ti=0 or ti=10) and (ss11s22=1 or ss11s22=3) then
        a1(p)=SQR((w33(p))^2 + (z33(p)^2))
    end if
    if (ti=0 or ti=10) and  ss11s22=3 then
        aa(p)=SQR((M1(p))^2 + (M2(p)^2))
    end if
    if (ti=0 or ti=10) and ss11s22=2  then
        a1(p)=SQR((M1(p))^2 + (M2(p)^2))
    end if
    if ti=1 and (ss11s22=1 or ss11s22=3) then
        a1(p)=w33(p)
    end if
    if ti=1 and ss11s22=2  then
        a1(p)=M1(p)
    end if
    if ti=1 and ss11s22=3 then
        aa(p)=M1(p)
    end if
    if ti=4 and (ss11s22=1 or ss11s22=3)  then
        a1(p)=ms11(p)
    end if
    if ti=4 and ss11s22=3 then
        aa(p)=ms22(p)
    end if
    if ti=4 and ss11s22=2 then
        a1(p)=ms22(p)
    end if
    if ti=9 and (ss11s22=1 or ss11s22=3)  then
        a1(p)=10^((ms11(p))/20)
    end if
    if ti=9 and ss11s22=3  then
        aa(p)=10^((ms22(p))/20)
    end if
    if ti=9 and ss11s22=2 then
        a1(p)=10^((ms22(p))/20)
    end if
    if ti=2 and (ss11s22=1 or ss11s22=3) then
        a1(p)=-(10^12)/(z33(p)*omega)
    end if
    if ti=2 and ss11s22=2  then
        a1(p)=-(10^12)/(M2(p)*omega)
    end if
    if ti=2 and  ss11s22=3 then
        aa(p)=-(10^12)/(M2(p)*omega)
    end if
    if ti=3 and (ss11s22=1 or ss11s22=3) then
        a1(p)=(10^9)*z33(p)/omega
    end if
    if ti=3 and ss11s22=2  then
        a1(p)=(10^9)*M2(p)/omega
    end if
    if ti=3 and ss11s22=3  then
        aa(p)=(10^9)*M2(p)/omega
    end if
    if (ti=5 or ti=7) and (ss11s22=1 or ss11s22=3) then
        a1(p)=-(10^12)*z33(p)/(omega*(w33(p)^2 + z33(p)^2))
    end if
    if (ti=5 or ti=7) and ss11s22=2  then
        a1(p)=-(10^12)*M2(p)/(omega*(M1(p)^2 + M2(p)^2))
    end if
    if (ti=5 or ti=7) and ss11s22=3  then
        aa(p)=-(10^12)*M2(p)/(omega*(M1(p)^2 + M2(p)^2))
    end if
    if (ti=6 or ti=8) and (ss11s22=1 or ss11s22=3) then
        a1(p)=(10^9) *(z33(p)^2 +w33(p)^2)/(omega*z33(p))
    end if
    if (ti=6 or ti=8) and ss11s22=2  then
        a1(p)=(10^9) *(M2(p)^2 +M1(p)^2)/(omega*M2(p))
    end if
    if (ti=6 or ti=8) and ss11s22=3  then
        aa(p)=(10^9) *(M2(p)^2 +M1(p)^2)/(omega*M2(p))
    end if

    if (ti=0 or ti=10) and (ss11s22=1 or ss11s22=3) then
        t1(p)=atan2(z33(p),w33(p))*(180/pi) 
    end if
    if (ti=0 or ti=10) and ss11s22=2  then
        t1(p)=atan2(M2(p),M1(p))*(180/pi)
    end if
    if (ti=0 or ti=10) and ss11s22=3 then
        tt(p)=atan2(M2(p),M1(p))*(180/pi)
    end if
    if ti=1 and (ss11s22=1 or ss11s22=3) then
        t1(p) = z33(p)
    end if
    if ti=1 and ss11s22=2 then
        t1(p) = M2(p)
    end if
    if ti=1 and ss11s22=3 then
        tt(p) = M2(p)
    end if
    if (ti=2 or ti=3  or ti=5 or ti=6) and (ss11s22=1 or ss11s22=3) then
        t1(p)=abs(z33(p)/w33(p))
    end if
    if (ti=2 or ti=3  or ti=5 or ti=6) and ss11s22=2 then
        t1(p)=abs(M2(p)/M1(p))
    end if
    if (ti=2 or ti=3  or ti=5 or ti=6) and ss11s22=3 then
        tt(p)=abs(M2(p)/M1(p))
    end if

    if (ti=4 or ti=9) and (ss11s22 = 1 or ss11s22 = 3) then
        t1(p)=as11(p)
    end if
    if (ti=4 or ti=9) and ss11s22 = 2 then
        t1(p)=as22(p)
    end if
    if (ti=4 or ti=9) and ss11s22 = 3 then
        tt(p)=as22(p)
    end if
    if (ti=7 or ti=8) and (ss11s22=1 or ss11s22=3) then
        t1(p)= (w33(p)^2 + z33(p)^2)/w33(p)
    end if
    if (ti=7 or ti=8) and ss11s22=2 then
        t1(p)= (M1(p)^2 + M2(p)^2)/M1(p)
    end if
    if (ti=7 or ti=8) and ss11s22=3 then
        tt(p)= (M1(p)^2 + M2(p)^2)/M1(p)
    end if
end sub

sub acqui
    'startorder
    usberror=0
    time5=timer
    if nbsamp=6 then plouf=64
    if nbsamp=13 then plouf=65
    if nbsamp=27 then plouf=66
    if nbsamp=55 then plouf=67
    if nbsamp=111 then plouf=68
    if nbsamp=223 then plouf=69
    if nbsamp=447 then plouf=70
    if nbsamp=895 then plouf=71
    'put #f, ,plouf
    startorder=chr(plouf)
    print #f,startorder;
    received=""
    sleep 30 :relax=1
    while len(received) <(7*(nbsamp+1)+1)

    'for t=0 to nbsamp
        t=len(received)
        if t>50*relax then
            sleep 30 :relax=relax+1
        end if
        
            l=inkey$
            if  l=" " then
                stoprequest=1 :zq22=0
                if (nbsamp-t/7)>50 then
                    locate 31,rep+2 :color 0,14 
                    print "      Wait      " :color 15,0
                end if
            end if
            getmouse x,y,wheel,bouton
            if x>(rep+1)*8 and x<(rep+17)*8 and y>431+16*8 and y<448+16*8 then
                if zq22=0 then
                    locate 36,rep+2 :color 0,15
                    if  (cal<1 or cal>6) then print " Stop           "
                    if  (cal=2 or cal=4 or cal=6) then print " Abort calibrate"
                    zq22=1 :color 15,0
                end if
            else
                if zq22=1 then
                    locate 36,rep+2 :color 15,0
                    if va=1 and (cal<1 or cal>6) then print " Stop           "
                    if va=1 and (cal=2 or cal=4 or cal=6) then print " Abort calibrate"
                    zq22=0 :line ((rep+1)*8,431+16*8)-((rep+17)*8,448+16*8),14,b

                end if
            end if
            if zq22=1 then 'bouton start 
                if bouton=1 and cleft=0 then
                    stoprequest=1 
                    cleft=1 :zq22=0
                    if (nbsamp-t/7)>50 then
                        locate 31,rep+2 :color 0,14 
                        print "      Wait      " :color 15,0
                    end if                    
                end if
            end if
            if bouton=0 then cleft=0
        sleep 0.1
        if loc(f)>0 then
            ressu=input(loc(f),f)
            received=received+ressu
        end if
        time6=timer
        if time6-time5>7 then usberror=1 :goto timeout
    wend
    for t=0 to nbsamp
        M(t)=0 :Q(t)=0
        for k=0 to 6
            'get #f, ,fx
            fx=asc(left(received,1))
            if k=0 then goto sotte
            if bit(fx,7)=-1 then M(t)=bitset(M(t),31-(k-1)*4)
            if bit(fx,6)=-1 then Q(t)=bitset(Q(t),31-(k-1)*4)
            if bit(fx,5)=-1 then M(t)=bitset(M(t),30-(k-1)*4)
            if bit(fx,4)=-1 then Q(t)=bitset(Q(t),30-(k-1)*4)
            if bit(fx,3)=-1 then M(t)=bitset(M(t),29-(k-1)*4)
            if bit(fx,2)=-1 then Q(t)=bitset(Q(t),29-(k-1)*4)
            if bit(fx,1)=-1 then M(t)=bitset(M(t),28-(k-1)*4)
            if bit(fx,0)=-1 then Q(t)=bitset(Q(t),28-(k-1)*4)
            sotte:
            received=right(received,(len(received)-1))
        next k
        continu:
    next t
    timeout:
end sub

sub frequence
    'zute1=timer
    N1=Cuint((freq(p)* &h100000000)/cclock)  'N1=entier a mettre dans DDS1
    N2=N1+716 'calcul de l'entier a renter dans DDS2 pour avoir 25.006011Hz
    'de plus que dans DDS1, si la frequence de l'horloge est 150MHz
    'ecriture des 40 bits  dans les 2 genes DDS
    'ecriture de la frequence  LSB en premier

    bid =&hc0
    'put #f, ,bid 'commande pour dire a arduino que l'on va envoyer la frequence
    freqecri=chr(bid)
    print #f,freqecri;
    sleep 1
    freqstring=""
    for i = 0 to 7
        bid = 0
        if bit(N1, 4*i)=-1 then bid = bitset (bid,0)
        if bit(N2, 4*i)=-1 then bid = bitset (bid,1)
        if bit(N1, 4*i+1)=-1 then bid = bitset (bid,2)
        if bit(N2, 4*i+1)=-1 then bid = bitset (bid,3)
        if bit(N1, 4*i+2)=-1 then bid = bitset (bid,4)
        if bit(N2, 4*i+2)=-1 then bid = bitset (bid,5)
        if bit(N1, 4*i+3)=-1 then bid = bitset (bid,6)
        if bit(N2, 4*i+3)=-1 then bid = bitset (bid,7)

        'put #f, , bid   'envoie de 8 bytes a arduino pour la frequence de dds1 & dds2
        freqstring=freqstring+chr(bid)
    next i
    print #f,freqstring;
end sub

sub resetz
   z1=0 :z2=0 :z3=0 :z4=0 :z5=0 :z6=0 :z7=0 :z8=0 :z9=0 :z10=0 :z11=0
    z12=0 :z13=0 :z14=0 :z15=0 :z16=0 :z17=0 :z18=0
    z22=0 :z23=0 :z24=0 :z25=0
end sub


sub menu
screenset 2,0
cls

if z1=1 then color 0,14
if z1=0 then color 14,0
if ti=0 then
    locate 2,rep+2
    print " Impedance vs frequency  "
    locate 3,rep+2
    print "  z() & arg(z)(deg)   "
end if
if ti=1 then
    locate 2,rep+2
    print " Impedance vs frequency  "
    locate 3,rep+2
    print "   Re(z)() & Im(z)()   "
end if
if ti=2 then
    locate 2,rep+2
    print "Capacitance vs frequency "
    locate 3,rep+2
    print " C & Q                   "
    cserie()
end if
if ti=3 then
    locate 2,rep+2
    print " Inductance vs frequency "
    locate 3,rep+2
    print " L & Q                   "
    lserie()
end if
if ti=4 then
    locate 2,rep+2
    print "    s11 vs frequency     "
    locate 3,rep+2
    print "s11(dB) & arg(s11)(deg)"
    color 14,0
end if
if ti=5 then
    locate 2,rep+2
    print "Capacitance vs frequency "
    locate 3,rep+2
    print " C & Q                   "
    cpara()
end if
if ti=6 then
    locate 2,rep+2
    print " Inductance vs frequency "
    locate 3,rep+2
    print " L & Q                   "
    lpara()
end if
if ti=7 then
    locate 2,rep+2
    print "Capacitance vs frequency "
    locate 3,rep+2
    print " C & R                   "
    cpara()
end if
if ti=8 then
    locate 2,rep+2
    print " Inductance vs frequency "
    locate 3,rep+2
    print " L & R                   "
    lpara()
end if
if ti=9 then
    locate 2,rep+2
    print "    s11 vs frequency     "
    locate 3,rep+2
    print "s11(U) & arg(s11)(deg) "
end if
if ti=10 then
    locate 2,rep+2
    print " Impedance vs frequency  "
    locate 3,rep+2
    print "    z()  log scale    "
end if

locate 6,rep+2 :color 14,0
if ti=0 then print " z "
if ti=1 then print "Re(z)"
if ti=2 then print " C   "
if ti=3 then print " L   "
if ti=4 then print "s11"
if ti=5 then print " C   "
if ti=6 then print " L   "
if ti=7 then print " C   "
if ti=8 then print " L   "
if ti=9 then print "s11"
if ti=10 then print " z "
locate 7,rep+2 :color 14,0
if ti=0 then print " () "
if ti=1 then print " () "
if ti=2 then print "(pF) "
if ti=3 then print "(nH) "
if ti=4 then print "(dB) "
if ti=5 then print "(pF) "
if ti=6 then print "(nH) "
if ti=7 then print "(pF) "
if ti=8 then print "(nH) "
if ti=9 then print " (U) "
if ti=10 then print " () "



locate 6,rep+8 :color 15
print "Max:"
locate 6,rep+12
print using "##########.###";maax(ti)
locate 7,rep+8 :color 15
print "MIN:"
locate 7,rep+12 
print using "##########.###";miin(ti)
if ti<10 then
    locate 8,rep+7 :color 15
    print "/div:"
    locate 8,rep+12
    print using "##########.###";(maax(ti)-miin(ti))/10
end if

locate 10,rep+2 :color 10
if ti=0 then print " arg "
if ti=1 then print "Im(z)"
if ti=2 then print " Q   "
if ti=3 then print " Q   "
if ti=4 then print " arg "
if ti=5 then print " Q   "
if ti=6 then print " Q   "
if ti=7 then print " R   "
if ti=8 then print " R   "
if ti=9 then print " arg "
if ti=10 then print " arg "
locate 11,rep+2 :color 10
if ti=0 then print "(deg)"
if ti=1 then print "()  "
if ti=2 then print "(U)  "
if ti=3 then print "(U)  "
if ti=4 then print "(deg)"
if ti=5 then print "(U)  "
if ti=6 then print "(U)  "
if ti=7 then print "()  "
if ti=8 then print "()  "
if ti=9 then print "(deg)"
if ti=10 then print "(deg)"

locate 10,rep+8 :color 15
print "Max:"
locate 10,rep+12
print using "##########.###";maxa(ti)
locate 11,rep+8 
print "MIN:"
locate 11,rep+12
print using "##########.###";mina(ti)
if ti<10 then
    locate 12,rep+7
    print "/div:"
    locate 12,rep+12
    print using "##########.###";(maxa(ti)-mina(ti))/10
end if


locate 14,rep+2 :color 15
print "freq  Max:"
locate 14,rep+13
print using "#########.##";fstop
locate 15,rep+2 
print "(Hz)  Min:"
locate 15,rep+13
print using "#########.##";fstart
if linlog=0 then
    locate 16,rep+7
    print "/div:"
    locate 16,rep+13
    print using "#########.##";(fstop-fstart)/10
    locate 17,rep+5
    print "center:"
    locate 17,rep+13
    print using "#########.##";center
    locate 18,rep+7
    print "span:"
    locate 18,rep+13
    print using "#########.##";span
end if
locate 20,rep+6
if linlog=0 then print "sweep: linear"
if linlog=1 then print "sweep: log   "
locate 21,rep+2
print "meas/scan:";nb

if sxp=2 then
    locate 24,rep+2
    print "Parameter:"
    locate 24,rep+12
    if ss11s22=1 then
        color 15,0
        if z14=1 then color 0,15
        print " s11 (input)  "
    end if
    if ss11s22=2 then
        color 15,0
        if z14=1 then color 0,15
        print " s22 (output) "
    end if
    if ss11s22=3 then
        color 14 :print " s11"
        locate 24, rep+17 :color 15
        print "&"
        locate 24,rep+19 :color 1
        print "s22"
        if z14=1 then 
            color 0,15 :locate 24,rep+12
            print " s11 & s22    "
        end if
    end if
    color 15,0
end if

locate 25,rep+4 :color 15,0
print "display:"
locate 25,rep+12
if z15=1 then color 0,15
if z15=0 then color 15,0
if ti=1 then
    if dis=0 then print " ,          "
    if dis=1 then print "             "
end if
if ti=2 or ti=5 then
    if dis=0 then print " pF,U         "
    if dis=1 then print " pF           "
end if
if ti=3 or ti=6 then
    if dis=0 then print " nH,U         "
    if dis=1 then print " nH           "
end if
if ti=8 then
    if dis=0 then print " nH,         "
    if dis=1 then print " nH           "
end if
if ti=7 then
    if dis=0 then print " pF,         "
    if dis=1 then print " pF           "
end if
if ti=0 or ti=10 then
    if dis=0 then print " ,deg        "
    if dis=1 then print "             "
end if
if ti=4 then
    if dis=0 then print " dB,deg       "
    if dis=1 then print " dB           "
end if
if ti=9 then
    if dis=0 then print " U,deg        "
    if dis=1 then print " U            "
end if
color 15,0

locate 28,rep+3
print "Copy Screen to File" 
locate 38,rep+2
print " Help "
locate 40,rep+2
print " File Access "
locate 42,rep+2
print " Exit "

if ti=0 or ti=10 then
 locate 45,2
 print "marker   1:             Hz                                deg "
 color 14 :locate 45,44 :print " " :color 10 :locate 45,61 :print "deg" :color 15
 locate 46,2
 print "marker   2:             Hz                                deg "
 color 14 :locate 46,44 :print " " :color 10 :locate 46,61 :print "deg" :color 15
 locate 47,2
 print "marker 2-1:             Hz                                deg "
 color 14 :locate 47,44 :print " " :color 10 :locate 47,61 :print "deg" :color 15
end if
if ti=1 then
 locate 45,2
 print "marker   1:             Hz                                  "
 color 14 :locate 45,44 :print " " :color 10 :locate 45,61 :print "  " :color 15
 locate 46,2
 print "marker   2:             Hz                                  "
 color 14 :locate 46,44 :print "  " :color 10 :locate 46,61 :print "  " :color 15
 locate 47,2
 print "marker 2-1:             Hz                                  "
 color 14 :locate 47,44 :print "  " :color 10 :locate 47,61 :print "  " :color 15
end if
if ti=2  or ti=5 then
 locate 45,2
 print "marker   1:             Hz                pF               U  "
 color 14 :locate 45,44 :print "pF" :color 10 :locate 45,61 :print "U  " :color 15
 locate 46,2
 print "marker   2:             Hz                pF               U  "
 color 14 :locate 46,44 :print "pF" :color 10 :locate 46,61 :print "U  " :color 15
 locate 47,2
 print "marker 2-1:             Hz                pF               U  "
 color 14 :locate 47,44 :print "pF" :color 10 :locate 47,61 :print "U  " :color 15
end if
if ti=7 then
 locate 45,2
 print "marker   1:             Hz                pF                 "
 color 14 :locate 45,44 :print "pF" :color 10 :locate 45,61 :print "  " :color 15
 locate 46,2
 print "marker   2:             Hz                pF                 "
 color 14 :locate 46,44 :print "pF" :color 10 :locate 46,61 :print "  " :color 15
 locate 47,2
 print "marker 2-1:             Hz                pF                 "
 color 14 :locate 47,44 :print "pF" :color 10 :locate 47,61 :print "  " :color 15
end if
if ti=3 or ti=6 then
 locate 45,2
 print "marker   1:             Hz                nH               U  "
 color 14 :locate 45,44 :print "nH" :color 10 :locate 45,61 :print "U  " :color 15
 locate 46,2
 print "marker   2:             Hz                nH               U  "
 color 14 :locate 46,44 :print "nH" :color 10 :locate 46,61 :print "U  " :color 15
 locate 47,2
 print "marker 2-1:             Hz                nH               U  "
 color 14 :locate 47,44 :print "nH" :color 10 :locate 47,61 :print "U" :color 15
end if
if ti=8 then
 locate 45,2
 print "marker   1:             Hz                nH                 "
 color 14 :locate 45,44 :print "nH" :color 10 :locate 45,61 :print "  " :color 15
 locate 46,2
 print "marker   2:             Hz                nH                 "
 color 14 :locate 46,44 :print "nH" :color 10 :locate 46,61 :print "  " :color 15
 locate 47,2
 print "marker 2-1:             Hz                nH                 "
 color 14 :locate 47,44 :print "nH" :color 10 :locate 47,61 :print "" :color 15
end if
if ti=4 then
 locate 45,2
 print "marker   1:             Hz                dB               deg "
 color 14 :locate 45,44 :print "dB" :color 10 :locate 45,61 :print "deg" :color 15
 locate 46,2
 print "marker   2:             Hz                dB               deg "
 color 14 :locate 46,44 :print "dB" :color 10 :locate 46,61 :print "deg" :color 15
 locate 47,2
 print "marker 2-1:             Hz                dB               deg "
 color 14 :locate 47,44 :print "dB" :color 10 :locate 47,61 :print "deg" :color 15
end if
if ti=9 then
 locate 45,2
 print "marker   1:             Hz                U                deg "
 color 14 :locate 45,44 :print "U " :color 10 :locate 45,61 :print "deg" :color 15
 locate 46,2
 print "marker   2:             Hz                U                deg "
 color 14 :locate 46,44 :print "U " :color 10 :locate 46,61 :print "deg" :color 15
 locate 47,2
 print "marker 2-1:             Hz                U                deg "
 color 14 :locate 47,44 :print "U " :color 10 :locate 47,61 :print "deg" :color 15
end if
locate 45,11 :color 12 :print "1"  :locate 47,11 :print "1"
locate 46,11 :color 13 :print "2"  :locate 47,9 :print "2" :color 15

end sub

sub z2sub 'pour editer gain max et gain min
    if num=1 then num=0 :goto numeric
    atenchar:
    l=inkey$
    sleep 2
    if l="" then goto atenchar
    if asc(l,1)=27 then
        sort=1 :goto finz2sub
    end if
    l=left$(l,1)
    if asc(l)>44 and asc(l)<58 and not(asc(l)=47) then
        numeric:
        if len(aw)<13 then
            aw=aw+l
            if z2=1 then 
                locate 6,rep+12 :color 0,14
                print "              "
                locate 6,rep+12 :print aw
            end if
            if z3=1 then 
                locate 7,rep+12 :color 0,14
                print "              "
                locate 7,rep+12 :print aw
            end if            
            'cente=0
        end if
    end if
    if asc(l)=8 then
        lu=len(aw)
        if lu>0 then lu=lu-1
        aw=left$(aw,lu)
        if z2=1 then 
            locate 6,rep+12 :color 0,14
            print "              "
            locate 6,rep+12 :print aw
        end if
        if z3=1 then 
            locate 7,rep+12 :color 0,14
            print "              "
            locate 7,rep+12 :print aw
        end if        
    end if
    if asc(l)=13 or (l="n" and (ti=3 or ti=6 or ti=8)) or (l="p" and (ti=2 or ti=5 or ti=7)) then
    'if asc(l)=13 then
        fdd=val(aw)
        if ((fdd>-999999999.98 and ti<10) or (fdd>0.0008 and ti=10)) and fdd<9999999999.98 then
            if z2=1 then maax(ti)=fdd
            if z3=1 then miin(ti)=fdd
            aw="" 'on vide le buffer de caracteres
            goto finz2sub
        end if
        if z2=1 then locate 6,rep+12
        if z3=1 then locate 7,rep+12
        print "              "
        aw=""
        goto atenchar
    end if
    if (l="n" and (ti=2 or ti=5 or ti=7)) or (l="u" and (ti=3 or ti=6 or ti=8)) or (l="k" and (ti=0 or ti=1 or ti=10)) then
        fdd=1000*val(aw)
        if ((fdd>-999999999.98 and ti<10) or (fdd>0.0008 and ti=10)) and fdd<9999999999.98 then
            if z2=1 then maax(ti)=fdd
            if z3=1 then miin(ti)=fdd
            aw="" 'on vide le buffer de caracteres
            goto finz2sub
        end if
        if z2=1 then locate 6,rep+12
        if z3=1 then locate 7,rep+12
        print "              "
        aw=""
        goto atenchar
    end if
    if (l="u" and (ti=2 or ti=5 or ti=7)) or ((l="m"or l="M") and (ti=3 or ti=6 or ti=8 or ti=10 or ti=0 or ti=1))  then
        fdd=1000000*val(aw)
        if ((fdd>-999999999.98 and ti<10) or (fdd>0.0008 and ti=10)) and fdd<9999999999.98 then
            if z2=1 then maax(ti)=fdd
            if z3=1 then miin(ti)=fdd
            aw="" 'on vide le buffer de caracteres
            goto finz2sub
        end if
        if z2=1 then locate 6,rep+12
        if z3=1 then locate 7,rep+12
        print "              "
        aw=""
        goto atenchar
    end if
    goto atenchar
    finz2sub:
    color 15,0
end sub

sub z4sub  'pour editer phase (delay) max et min
    if num=1 then num=0 :goto numeric
    atenchar:
    l=inkey$
    sleep 2
    if l="" then goto atenchar
    if asc(l,1)=27 then
        sort=1 :goto finz4sub
    end if
    l=left$(l,1)
    if asc(l)>44 and asc(l)<58 and not(asc(l)=47) then
        numeric:
        if len(aw)<11 then
            aw=aw+l
            if z4=1 then 
                locate 10,rep+12 :color 0,14
                print "              "
                locate 10,rep+12 :print aw
            end if
            if z5=1 then 
                locate 11,rep+12 :color 0,14
                print "              "
                locate 11,rep+12 :print aw
            end if            
            'cente=0
        end if
    end if
    if asc(l)=8 then
        lu=len(aw)
        if lu>0 then lu=lu-1
        aw=left$(aw,lu)
        if z4=1 then 
            locate 10,rep+12 :color 0,14
            print "              "
            locate 10,rep+12 :print aw
        end if
        if z5=1 then 
            locate 11,rep+12 :color 0,14
            print "              "
            locate 11,rep+12 :print aw
        end if        
    end if
    if asc(l)=13 then
        fdd=val(aw)
        if fdd>-999999999.98 and fdd<9999999999.98 then
            if z4=1 then maxa(ti)=fdd
            if z5=1 then mina(ti)=fdd
            aw="" 'on vide le buffer de caracteres
            goto finz4sub
        end if
        if z4=1 then locate 10,rep+12
        if z5=1 then locate 11,rep+12
        print "              "
        aw=""
        goto atenchar
    end if
    if l="k" and (ti=1 or ti=7 or ti=8) then
        fdd=1000*val(aw)
        if fdd>-999999999.98 and fdd<9999999999.98 then
            if z4=1 then maxa(ti)=fdd
            if z5=1 then mina(ti)=fdd
            aw="" 'on vide le buffer de caracteres
            goto finz4sub
        end if
        if z4=1 then locate 10,rep+12
        if z5=1 then locate 11,rep+12
        print "              "
        aw=""
        goto atenchar
    end if
    if (l="m" or l="M") and (ti=1 or ti=7 or ti=8) then
        fdd=1000000*val(aw)
        if fdd>-999999999.98 and fdd<9999999999.98 then
            if z4=1 then maxa(ti)=fdd
            if z5=1 then mina(ti)=fdd
            aw="" 'on vide le buffer de caracteres
            goto finz4sub
        end if
        if z4=1 then locate 10,rep+12
        if z5=1 then locate 11,rep+12
        print "              "
        aw=""
        goto atenchar
    end if
    goto atenchar
    finz4sub:
    color 15,0
end sub
sub z14sub  'pour editer length

end sub

sub z6sub  'pour editer fmax , fmin, fcenter ,span

end sub        

sub help
    cls
    locate 2,ali+30 :color 14 :print "Help" :color 15
    locate 5,ali+1
    print "Choose between  - z() & arg(z)(deg) :impedance (module & phase)"
    locate 6,ali+1
    print "                - Re(z)() & Im(z)()  :real part and imaginary part of z"
    locate 7,ali+1
    print "                - C(pF) & Q(U) :capacitance & quality factor (series model)"
    locate 8,ali+1
    print "                - L(nH) & Q(U) :inductance & quality factor (series model)"
    locate 9,ali+1
    print "                - S11(dB) & arg(s11)(deg) : s11 module (dB scale) & s11 phase"
    locate 10,ali+1
    print "                - C(pF) & Q(U) :capacitance & quality factor (parallel model)"
    locate 11,ali+1
    print "                - L(nH) & Q(U) :inductance & quality factor (parallel model)"
    locate 12,ali+1
    print "                - C(pF) & R() :capacitance & parallel resistance"
    locate 13,ali+1
    print "                - L(nH) & R() :inductance & parallel resistance"
    locate 14,ali+1
    print "                - S11(U) & arg(s11)(deg) : s11 module (linear scale) & s11 phase"
    locate 15,ali+1
    print "                - z() : impedance module (log scale)"
    locate 17,ali+1
    print "If the file extension is s2p , select the parameters to be displayed : input (S11), output (S22) or both"
    locate 17,ali+43 :color 6 :print "parameters"
    locate 18, ali+1 :color 15
    print "To select between different possibilities, use the mouse buttons (left or right) or the mouse scroll wheel"
    locate 19,ali+1
    print "To change a number, put the mouse cursor on this number then type the new number + ""enter"""
    locate 20,ali+1
    print "To increment/decrement a digit of a number, put the mouse cursor on the digit, then move the mouse scroll wheel"
    locate 21,ali+1
    print "Adjust the scales to your needs: "
    locate 21,ali+34 :color 6 :print ", deg, pF, nH, U, Hz" :color 15 
    locate 22,ali+1
    print "To setup the scales, you can use : n=nF,u=uF,u=uH,m=mH,k=k,m=M"
    locate 23,ali+1
    print "To move the markers, use the mouse."
    locate 23,ali+13 :color 6 :print "markers"
    locate 24,ali+1 :color 15
    print "With display, you can choose to display only the yellow curve"
    locate 24,ali+6 :color 6 :print "display"
    locate 25,ali+1 :color 15
    print "To get a copy of the screen (a bmp file), use "
    locate 25,ali+47 :color 6 :print "Copy Screen to File"
    locate 45,ali+1 :color 1
    print "Exit Help (Esc)" :color 15    

    testclav:
    l=inkey$
    if asc(l,1)=27 then goto quitelp
    sleep 14
    getmouse x,y,wheel,bouton
    if x>(ali)*8 and x<(ali+16)*8 and y>(44*16) and  y<=(45*16)   then 
        if zzz5=0 then
            locate 45,ali+1 :color 0,1 :print "Exit Help (ESC)"
            zzz5=1 :color 15,0
        end if
    else
        if zzz5=1 then
            locate 45,ali+1 :color 1,0 :print "Exit Help (ESC)"
            zzz5=0 :color 15
        end if
    end if
    if zzz5=1 then                     'exit
        if bouton=1 and cleft=0 then
            goto quitelp
            cleft=1 :zzz5=0 
        end if
        if bouton=2 and cright=0 then
            goto quitelp
            cright=1 :zzz5=0 
        end if    
        if bouton=0 then
            cleft=0 :cright=0
        end if
    end if    
    goto testclav
    quitelp:
end sub

sub adjust

end sub

sub savefile
   
    sauvpo=0
    acqi=0
    choi=3 ' 1 pour s2p(s11), 2 pour s2p(s22), 3 pour BMP, 0 pour s1p
    cls           
    zz1=0 :zz2=0 :zz3=0 :zz4=0
    locate 5,5 : print "Save As"
    locate 8,10 : print "file name :"
    locate 10,10 : print "     type :"
    locate 10,22 : print "  bmp     "
    locate 12,22 : print "  save    "

    locate 8,22  : print " noname "
    copynom="noname"
    color 15
    locate 45,ali+2 :color 1
    print "Exit (Esc)"

    testecla:
    l=inkey$
    sleep 12
    if l="" then goto testmouse
    if asc(l,1)=27 then
        goto finsubsavefile
    end if
    testmouse:
    getmouse x,y,wheel,bouton
    if x>(ali)*8 and x<(ali+60)*8 and y>(7*16) and  y<=(8*16)   then  'file name
        if zz1=1 then
            if (bouton=1 and cleft=0) then
                locate 8,ali+20 :color 0,14
                print "_                                        "
                cleft=1 
            end if
            if bouton=0 then cleft=0
        end if
        if zz1=0 then
            locate 8,ali+20 :color 0,15
            if len(copynom)<41 then
                copinom=copynom
                while len(copinom)<41
                    copinom=copinom+" "
                wend
                print copinom
            else
                print copynom
            end if
            zz1=1 :color 15,0
        end if
    else
        if zz1=1 then
            locate 8,ali+20 :color 15,0
            if len(copynom)<41 then
                copinom=copynom
                while len(copinom)<41
                    copinom=copinom+" "
                wend
                print copinom
            else
                print copynom
            end if            
            zz1=0
        end if
    end if
    if x>(ali)*8 and x<(ali+30)*8 and y>(11*16) and  y<=(12*16)   then  'save
        if zz3=0 then
            locate 12,ali+20 :color 0,15
            print "save     " 
            zz3=1 :color 15,0
        end if
    else
        if zz3=1 then
            locate 12,ali+20 :color 15,0
            print "save     " 
            zz3=0
        end if
    end if
    if x>(ali)*8 and x<(ali+12)*8 and y>(44*16) and  y<=(45*16)   then 'Exit
        if zz4=0 then
            locate 45,ali+2 :color 0,1 :print "Exit (ESC)"
            zz4=1 :color 15,0
        end if
    else
        if zz4=1 then
            locate 45,ali+2 :color 1,0 :print "Exit (ESC)"
            zz4=0 :color 15
        end if
    end if
    
    if zz4=1 then                     'exit
        if bouton=1 and cleft=0 then
            goto finsubsavefile
            cleft=1 :zz4=0 
        end if
        if bouton=2 and cright=0 then
            goto finsubsavefile
            cright=1 :zz4=0 
        end if    
        if bouton=0 then
            cleft=0 :cright=0
        end if
    end if
    if zz3=1 then
        if bouton=1 and cleft=0 then
            if choi=0 then
                bobo=copynom + ".s1p"
                s1p()
                goto finsubsavefile
            end if
            if choi=1 then
                bobo=copynom + ".s2p"
                xistdja=dir$(bobo)
                if xistdja="" then
                    s2ps11()
                else 
                    ss1122=0 'pour dire que c'est s11 que l'on va ecrire
                    s1122dja()
                end if
                goto finsubsavefile
            end if
            if choi=2 then
                bobo=copynom + ".s2p"
                xistdja=dir$(bobo)
                if xistdja="" then
                    s2ps22()
                else 
                    ss1122=1 ' pour dire que c'est s12 que l'on va ecrire
                    s1122dja()
                end if 
                goto finsubsavefile
            end if
            if choi=3 then
                bmpecri=1
                goto finsubsavefile
            end if
            if bouton=0 then
                cleft=0 :cright=0
            end if
        end if
    end if

    l=left$(l,1)
    ll=asc(left$(l,1))
    if zz1=1 and ((ll>47 and ll<58) or (ll>64 and ll<91) or ll=95 or (ll>96 and ll<123)) then
        locate 8,23 :color 0 :print "                                         "
        goto typefilename
        'goto py10
        ppy10:
        l=inkey$
        sleep 10
        if l="" then goto ppy10
        if asc(l,1)=27 then
            goto finsubsavefile
        end if
        py10:
        l=left$(l,1)
        ll=asc(left$(l,1))
        if (ll>47 and ll<58) or (ll>64 and ll<91) or ll=95 or (ll>96 and ll<123) then
            typefilename:   
            if len(aw)<41 then
                acqi=1 :aw=aw+l
                locate 8,23 :color 0,14 
                print "                                         " 
                locate 8,23  :print aw
            end if
        end if
        if asc(l)=8 then
            lu=len(aw)
            if lu>0 then lu=lu-1
            aw=left$(aw,lu)
            locate 8,23 :color 0,14 
            print "                                         " 
            locate 8,23 :print aw
        end if
        if asc(l)=13 then
            if aw="" then
                aw=copynom
                locate 8,23 :color 0,15
                print "                                         "
                locate 8,23 :print copynom
                sleep 200
            else
                copynom=aw :locate 8,23 :color 0,15
                print "                                         "
                locate 8,23
                print copynom
                color 15,0
                line (1,29*16)-(1020,35*16),0,bf
                bubu=copynom + ".bmp"
                xist1=dir$(bubu)
                if xist1="" then
                else
                    locate 32,5 :print "The file ";bubu;" already exists."
                    locate 33,5 :print "So, this file will be overwritten."
                end if
            end if
            aw="" :acqi=0
            goto testecla
        end if
        if acqi=0 then goto testecla
        goto ppy10
    end if
    goto testecla
    finsubsavefile:
    cls
end sub


sub efasse
    line (164,112)-(254,127),0,b
    line (164,144)-(254,159),0,b
    line (164,176)-(254,191),0,b
    if sauvpo=0 then line (164,112)-(254,127),14,b
    if sauvpo=1 then line (164,144)-(254,159),14,b
    if sauvpo=2 then line (164,176)-(254,191),14,b
end sub

sub ecribmp
    fb=freefile
    bobo=copynom + ".bmp"
    open bobo for binary as #fb
    deuxbyte=&h0000 
    for i=1 to 31 'to reset the beginning of the bmp file
        put #fb,i*2,deuxbyte
    next i
    deuxbyte=&h4d42 '"BM"
    put #fb,1,deuxbyte
    quatrebyte=&hc0437 'file size
    put #fb,&h0003,quatrebyte
    quatrebyte=&h0436 'offset of the bitmap data
    put #fb,&h000b,quatrebyte
    quatrebyte=&h0028 'size of info header
    put #fb,&h000f,quatrebyte
    quatrebyte=&h0400 'bitmap width
    put #fb,&h0013,quatrebyte
    quatrebyte=&h300 'bitmap height
    put #fb,&h0017,quatrebyte
    deuxbyte=&h0001 'number of plane (=1)
    put #fb,&h001b,deuxbyte
    deuxbyte=&h0008 'bits per pixel
    put #fb,&h001d,deuxbyte
    quatrebyte=&h0000 'type of compression
    put #fb,&h001f,quatrebyte
    quatrebyte=&h0100 'number of colors
    put #fb,&h002f,quatrebyte
    put #fb,&h0033,quatrebyte 'number of important colors
    
    for i=0 to 255
        palette get i,rouge,vert,bleu
        zero=0 :red=rouge :green=vert :blue=bleu
        put #fb,,blue  'to write the palette
        put #fb,,green
        put #fb,,red
        put #fb,,zero
    next i
    for i=767 to 0 step -1
        ligne=""
        for k=0 to 1023
            pixel=point(k,i)
            ligne=ligne+chr(pixel)
        next k
        put #fb,,ligne
    next i
    close #fb
end sub


sub s2ps21
    while  len(titre) < 29 
        titre = titre + " "
    wend
    mxxx="!  anareso  " + titre + chr$(13) + chr$(10)
    mxxx=mxxx + "! parameter S" + chr$(13) + chr$(10) +"# HZ S DB R 50" + chr$(13) + chr$(10)
    bobo=copynom + ".s2p" 
    fff=freefile
    open bobo for binary as #fff
    close #fff
    kill bobo
    open bobo for binary as #fff
    put #fff,0,mxxx
    for i=0 to nb-1
    s21s12()
    dxxx=str(frec) +" 0.0 0.0 " + str(Axx)+" " +str(T1xx)
    dxxx=dxxx+ " 0.0 0.0 0.0 0.0 "+ chr$(13) + chr$(10)
    put #fff,,dxxx
    next i
    close #fff
end sub

sub s2ps12
    while len(titre) < 29 
        titre = titre + " "
    wend
    mxxx="!  anareso  " + titre + chr$(13) + chr$(10)
    mxxx=mxxx + "! parameter S" + chr$(13) + chr$(10) +"# HZ S DB R 50" + chr$(13) + chr$(10)
    bobo=copynom + ".s2p"
    fff=freefile
    open bobo for binary as #fff
    close #fff
    kill bobo
    open bobo for binary as #fff
    put #fff,0,mxxx
    for i=0 to nb-1
        s21s12()
        dxxx=str(frec) +" 0.0 0.0 0.0 0.0 " + str(Axx)+" " + str(T1xx)
        dxxx=dxxx+ " 0.0 0.0 "+ chr$(13) + chr$(10)
        put #fff,,dxxx
    next i
    close #fff
end sub

sub s21s12
    if linlog=1 then
        frec=(10^(log(fstop/fstart)/log(10)*i/(nb-1))*fstart)
    else
        frec=((fstop-fstart)*i/(nb-1)+fstart)
    end if
    if cal < 3 then
        Axx=20*log(sqr(w3L(i)^2 + z3L(i)^2))/log(10)
        T1xx=atan2(z3L(i),w3L(i))
        T1xx=T1xx*(180/pi)
    end if
    if (cal=3 or cal=4) then
        Axx=20*log(sqr(wnd(i)^2 + znd(i)^2))/log(10)
        T1xx=atan2(znd(i),wnd(i))
        T1xx=T1xx*(180/pi)
    end if
end sub

sub s2112dja

    'lecture du fichier s2p et eciture de spartemp.tmp

    c="" 'caractere lut dans le fichier s1p
    esclam=0 'esclam%=1 si on a lut un "!" en debut de ligne
    diese=0  'diese%=1  on  lit la ligne du "#" 
          'diese%=2 (ou plus) = on a deja lut la ligne du diese
    kk="" 'chaine de caractere d'une ligne max pour recopier de bibi dans baba 
    done = 0 'on n'a pas encore ecrit la frquence    
    'done% = 1 'on ecrit la frequence
    'done% = 2 'on a fini d'ecrire la frequence
    'done% = 3 'on ecrit le module de s11 en dB
    'done% = 4 'on a fini d'ecrire le module de s11
    'done% = 5 'on ecrit la phase de s11
    'done% = 6 'on a fini d'ecrire la phase de s11
    'done% = 7 'on ecrit le module de s21
    'done% = 8 'on a fini d'ecrire le module de s21
    'done% = 9 'on ecrit la phase de s21
    'done% = 10 'on a fini d'ecrire la phase de s21
    'done% = 11 'on ecrit le module de s12
    'done% = 12 'on a fini d'ecrire le module de s12
    'done% = 13 'on ecrit la phase de s12
    'done% = 14 'on a fini d'ecrire la phase de s12
    'done% = 15 'on ecrit le module de s22
    'done% = 16 'on a fini d'ecrire le module de s22
    'done% = 17 'on ecrit la phase de s22
    'done% = 18 'on a fini d'ecrire la phase de s22
    nbb=0 'numero de la frequence 
    freqqs="" 'pour ecrire la frequence
    ms11s=""  'pour ecrire le module de s11
    as11s=""  'pour ecrire la phase de s11 

    bibi=copynom + ".s2p"
    fff=freefile
    open bibi for binary as #fff 
    taille = lof(fff)
    baba="spartemp.tmp"
    ff2=freefile
    open baba for binary as #ff2


    bcl1:    'boucle de lecture du fichier s2p
    if taille = loc(fff) then goto finrcopi
    get #fff,,c
    if ss2112=0 and (done <6 or done >9) then
        kk=kk + c
    end if
    if ss2112=1 and (done <10 or done >13) then
        kk=kk + c
    end if
    if esclam=1 then
        if c=chr$(10) then
            esclam=0
            put #ff2,,kk
            kk="" 
        end if
        goto bcl1
    end if
    if diese=1 then 'mettre ici la lecture des formats
        if c=chr$(10) then
            put #ff2,,kk
            kk="" 
            diese=2
        end if 
        goto bcl1
    end if
    if c="!" then esclam=1
    if c="#" then diese=diese + 1
    if c=" " then
        if done =5 and ss2112=0 then
            i=nbb
            s21s12()
            kk=kk+ str(Axx) + " " +  str(T1xx) + " "
        end if
        if done =9 and ss2112=1 then
            i=nbb
            s21s12()
            kk=kk + str(Axx) + " " +  str(T1xx) + " "
        end if 
        if done mod 2 = 1 then done = done + 1 ' si done% est impair on l'incremente
    end if
    if (asc(c)>42 and asc(c)<58 and not(asc(c)=47)) or c="E" or c="e" then
        if diese = 0  or diese > 2 then goto erreur
        if done mod 2 = 0 then done = done + 1
    end if
    if c=chr$(10) then
        if (done > 0 and done < 17) or done >18  then goto erreur
        if done = 17 then
            done = 0
            put #ff2,,kk
            kk="" 
        end if 
        if done = 18 then
            done=0
            put #ff2,,kk
            kk="" 
        end if
        if nbb < (nb-1) then
            nbb = nbb + 1
        else
            goto finrcopi
        end if
    end if
    goto bcl1

    erreur:
    locate 5,5
    print " error : the file is not compatible "
    sleep 4000
    close #fff
    close #ff2
    goto findjasub

    finrcopi:
    close #fff
    close #ff2
    kill bibi
    NAME baba AS bibi
    findjasub:
end sub
sub wheel1
    kz=0
    if x<(rep+25)*8 then kz=0.001
    if x<(rep+24)*8 then kz=0.01
    if x<(rep+23)*8 then kz=0.1
    if x<(rep+21)*8 then kz=1
    if x<(rep+20)*8 then kz=10
    if x<(rep+19)*8 then kz=100
    if x<(rep+18)*8 then kz=1000
    if x<(rep+17)*8 then kz=10000
    if x<(rep+16)*8 then kz=100000
    if x<(rep+15)*8 then kz=1000000
    if x<(rep+14)*8 then kz=10000000
    if x<(rep+13)*8 then kz=100000000
    if x<(rep+12)*8 then kz=1000000000
    if x<(rep+22)*8 and x>=(rep+21)*8 then kz=0
end sub

sub wheel2
    kz=0
    if x<(rep+25)*8 then kz=0.001
    if x<(rep+24)*8 then kz=0.01
    if x<(rep+23)*8 then kz=0.1
    if x<(rep+21)*8 then kz=1
    if x<(rep+20)*8 then kz=10
    if x<(rep+19)*8 then kz=100
    if x<(rep+18)*8 then kz=1000
    if x<(rep+17)*8 then kz=10000
    if x<(rep+16)*8 then kz=100000
    if x<(rep+15)*8 then kz=1000000
    if x<(rep+14)*8 then kz=10000000
    if x<(rep+22)*8 and x>=(rep+21)*8 then kz=0
end sub


sub lserie
    line (910,39)-step(4,0)    'dessin de L petit format avec resistance en serie
    for i=0 to 2
        pset step(1,-1) :pset step(1,-1) :pset step(1,0)
        pset step(1,1) :pset step(1,1) :pset step(-1,1) :pset step(0,1)
        pset step(1,1) :pset step(1,-1) :pset step(0,-1) :pset step(-1,-1)
    next  i
    pset step(1,-1) :pset step(1,-1) :pset step(1,0)
    pset step(1,1)  :line step(1,1)-step(6,0)
    line step(0,0)-step(2,-2) :line step(0,0)-step(4,4) :line step(0,0)-step(4,-4)
    line step(0,0)-step(4,4) :line step(0,0)-step(4,-4) :line step(0,0)-step(2,2)
    line step(0,0)-step(4,0)
end sub

sub lpara
    line (910,39)-step(4,0) 'dessin de L avec resistance en parallele
    line step(0,-3)-step(0,6) :line step(0,0)-step(4,0)
    for i=0 to 2
        pset step(1,-1) :pset step(1,-1) :pset step(1,0)
        pset step(1,1) :pset step(1,1) :pset step(-1,1) :pset step(0,1)
        pset step(1,1) :pset step(1,-1) :pset step(0,-1) :pset step(-1,-1)
    next  i
    pset step(1,-1) :pset step(1,-1) :pset step(1,0) :pset step(1,1)
    line step(1,1)-step(4,0) :line step(0,0)-step(0,-6) :line step(0,3)-step(4,0)
    line step(-4,-3)-step(-4,0) :pset step(-1,-1) :line step(-1,-1)-step(-4,4)
    line step(0,0)-step(-4,-4) :line step(0,0)-step(-4,4) :line step(0,0)-step(-4,-4)
    pset step(-1,1) :line step(-1,1)-step(-4,0)
end sub

sub cpara
    line (910,39)-step(4,0)   'dessin de C et de R en parralele version 2
    line step(0,-3)-step(0,6)
    line step(0,0)-step(13,0)
    line step(0,-3)-step(0,6)
    line step(2,0)-step(0,-6)
    line step(0,3)-step(13,0)
    line step(0,0)-step(0,-6)
    line step(0,0)-step(-4,0)
    line step(0,0)-step(-2,-2)
    line step(0,0)-step(-2,2)
    line step(0,0)-step(-2,2)
    line step(0,0)-step(-4,-4)
    line step(0,0)-step(-4,4)
    line step(0,0)-step(-4,-4)
    line step(0,0)-step(-2,2)
    line step(0,0)-step(-4,0)
    line step(29,3)-step(4,0)
end sub

sub cserie
    line  (910,39)-step(5,0)   'dessin de C et de R en serie
    line step(0,-3)-step(0,6)
    line step(2,0)-step(0,-6)
    line step(0,3)-step(8,0)
    line step(0,0)-step(2,-2) :line step(0,0)-step(4,4) :line step(0,0)-step(4,-4)
    line step(0,0)-step(4,4) :line step(0,0)-step(4,-4) :line step(0,0)-step(2,2)
    line step(0,0)-step(4,0)
end sub

sub s1p

'ecriture dans un fichier s1p

    mxxx="!  anareso  "  + chr$(13) + chr$(10)
    mxxx=mxxx + "! parameter S" + chr$(13) + chr$(10) +"# HZ S DB R 50" + chr$(13) + chr$(10)
    bobo=copynom + ".s1p"
    fff=freefile
    open bobo for binary as #fff
    close #fff
    kill bobo
    fff=freefile
    open bobo for binary as #fff
    put #fff,1,mxxx
    for i=0 to nb-1
        s11s22()
        dxxx=str(freq(i)) +" "+ str(Axx)+" " +str(T1xx)+ chr$(13) + chr$(10)
        put #fff,,dxxx
    next i
    close #fff
end sub

sub s11s22
    if cal<7 then
        rel=(100/(w3L(i)^2+z3L(i)^2))*(w3L(i)-w3L(i)^2-z3L(i)^2)
        ima=(100/(w3L(i)^2+z3L(i)^2))*(-z3L(i))
        mods11=sqr((rel^2-2500+ima^2)^2+(100*ima)^2)/((rel+50)^2+ima^2)
        Axx=20*log(mods11)/log(10)
    else
        omega=2*pi*freq(i)
        denom=(1-lref*cref*omega^2)^2+(refr*cref*omega)^2
        zrefr=refr/denom 
        zrefi=(lref*omega-refr^2*cref*omega-lref^2*cref*omega^3)/denom
        w24=ws(i)-w3L(i) :zh24=zs(i)-z3L(i) :w13=wo(i)-wr(i) :zh13=zo(i)-zr(i)
        w41=w3L(i)-wo(i) :zh41=z3L(i)-zo(i) :w32=wr(i)-ws(i) :zh32=zr(i)-zs(i)
        wn=w24*w13-zh24*zh13 :zn=zh24*w13+zh13*w24
        wd=w41*w32-zh41*zh32 :zd=zh41*w32+zh32*w41
        whnd=(wn*wd+zn*zd)/(wd^2+zd^2)
        zhnd=(zn*wd-wn*zd)/(wd^2+zd^2)
        twnd=whnd*zrefr-zhnd*zrefi
        zhnd=whnd*zrefi+zrefr*zhnd
        whnd=twnd
        mods11=sqr(((whnd)^2-2500+(zhnd)^2)^2+(100*zhnd)^2)/((whnd+50)^2+(zhnd)^2)
        Axx=20*log(mods11)/log(10)
    end if 
    if cal<7 then
        wh3=(rel^2-2500+ima^2)/((rel+50)^2+ima^2)
        zh3=100*ima/((rel+50)^2+ima^2)
    else
        wh3=((whnd)^2-2500+(zhnd)^2)/((whnd+50)^2+(zhnd)^2)
        zh3=100*zhnd/((whnd+50)^2+(zhnd)^2)
    end if
    T1xx=atan2(zh3,wh3)*(180/pi)
end sub

sub s2ps11
    mxxx="!  anareso  "  + chr$(13) + chr$(10)
    mxxx=mxxx + "! parameter S" + chr$(13) + chr$(10) +"# HZ S DB R 50" + chr$(13) + chr$(10)
    bobo=copynom + ".s2p"
    fff=freefile
    open bobo for binary as #fff
    close #fff
    kill bobo
    fff=freefile
    open bobo for binary as #fff
    put #fff,1,mxxx
    for i=0 to nb-1
        s11s22()
        dxxx=str(freq(i)) +" "+ str(Axx)+" " +str(T1xx)
        dxxx=dxxx+ " 0.0 0.0 0.0 0.0 0.0 0.0 "+ chr$(13) + chr$(10)
        put #fff,,dxxx
    next i
    close #fff
end sub

sub s2ps22
    mxxx="!  anareso  "  + chr$(13) + chr$(10)
    mxxx=mxxx + "! parameter S" + chr$(13) + chr$(10) +"# HZ S DB R 50" + chr$(13) + chr$(10)
    bobo=copynom + ".s2p"
    fff=freefile
    open bobo for binary as #fff
    close #fff
    kill bobo
    fff=freefile
    open bobo for binary as #fff
    put #fff,1,mxxx
    for i=0 to nb-1
        s11s22()
        dxxx=str(freq(i)) +" 0.0 0.0 0.0 0.0 0.0 0.0 "
        dxxx=dxxx + str(Axx)+" " + str(T1xx) + chr$(13) + chr$(10)
        put #fff,,dxxx
    next i
    close #fff
end sub

sub s1122dja

    'lecture du fichier s2p et eciture de spartemp.tmp

    c="" 'caractere lut dans le fichier s1p
    esclam=0 'esclam%=1 si on a lut un "!" en debut de ligne
    diese=0  'diese%=1  on  lit la ligne du "#" 
          'diese%=2 (ou plus) = on a deja lut la ligne du diese
    kk="" 'chaine de caractere d'une ligne max pour recopier de bibi dans baba 
    done = 0 'on n'a pas encore ecrit la frquence    
    'done = 1 'on ecrit la frequence
    'done = 2 'on a fini d'ecrire la frequence
    'done = 3 'on ecrit le module de s11 en dB
    'done = 4 'on a fini d'ecrire le module de s11
    'done = 5 'on ecrit la phase de s11
    'done = 6 'on a fini d'ecrire la phase de s11
    'done = 7 'on ecrit le module de s21
    'done = 8 'on a fini d'ecrire le module de s21
    'done = 9 'on ecrit la phase de s21
    'done = 10 'on a fini d'ecrire la phase de s21
    'done = 11 'on ecrit le module de s12
    'done = 12 'on a fini d'ecrire le module de s12
    'done = 13 'on ecrit la phase de s12
    'done = 14 'on a fini d'ecrire la phase de s12
    'done = 15 'on ecrit le module de s22
    'done = 16 'on a fini d'ecrire le module de s22
    'done = 17 'on ecrit la phase de s22
    'done = 18 'on a fini d'ecrire la phase de s22
    nbb=0 'numero de la frequence 
    freqqs="" 'pour ecrire la frequence
    ms11s=""  'pour ecrire le module de s11
    as11s=""  'pour ecrire la phase de s11 

    bibi=copynom + ".s2p"
    fff=freefile
    open bibi for binary as #fff 
    taille = lof(fff)
    baba="spartemp.tmp"
    ff2=freefile
    open baba for binary as #ff2

    bcl2:      'boucle de lecture du fichier s2p
    if taille = loc(fff) then goto finrcopi
    get #fff,,c
    if ss1122=0 and (done <2 or done >5) then
        kk=kk + c
    end if
    if ss1122=1 and (done <14 or done >17) then
        kk=kk + c
    end if
    if esclam=1 then
        if c=chr$(10) then
            esclam=0
            put #ff2,,kk
            kk="" 
        end if
        goto bcl2
    end if
    if diese=1 then 'mettre ici la lecture des formats
        if c=chr$(10) then
            put #ff2,,kk
            kk="" 
            diese=2
        end if 
        goto bcl2
    end if
    if c="!" then esclam=1
    if c="#" then diese=diese + 1
    if c=" " then
        if done =1 and ss1122=0 then
            i=nbb
            s11s22()
            kk=kk+ str(Axx) + " " +  str(T1xx) + " "
        end if
        if done =13 and ss1122=1 then
            i=nbb
            s11s22()
            kk=kk + str(Axx) + " " +  str(T1xx) + " "
        end if 
        if done mod 2 = 1 then done = done + 1 ' si done est impair on l'incremente
    end if
    if (asc(c)>42 and asc(c)<58 and not(asc(c)=47)) or c="E" or c="e" then
        if diese = 0  or diese > 2 then goto erreur
        if done mod 2 = 0 then done = done + 1
    end if
    if c=chr$(10) then
        if (done > 0 and done < 17) or done >18  then goto erreur
        if done = 17 then
            done = 0
            put #ff2,,kk
            kk="" 
        end if 
        if done = 18 then
            done=0
            put #ff2,,kk
            kk="" 
        end if
        if nbb < (nb-1) then
            nbb = nbb + 1
        else
            goto finrcopi
        end if
    end if
    goto bcl2

    erreur:
    locate 5,5
    print " error : the file is not compatible "
    sleep 3500
    close #fff
    close #ff2
    goto findjasub

    finrcopi:
    close #fff
    close #ff2
    kill bibi
    NAME baba AS bibi
    findjasub:
end sub

sub setport
    cls
    locate 5,40 :color 14
    print "Serial Port Setting"
    locate 8,46 :color 15
    print "COM :   "
    locate 20,5 :color 6
    print "Within Windows menus : Device Manager | Port Settings | " 
    locate 21,5
    print "find the USB Serial Port COM address of the FTDI USB Serial Converter"
    locate 23,5
    print "Write this COM port Address in this menu, then Save & Exit "
    locate 45,ali+1 :color 1 :print "Exit (ESC)"
    locate 45,ali+52 :print "Save and Exit (F4)" :color 15
    bobo="configu"
    ff=freefile
    open bobo for binary as #ff
    get #ff,1,usbcomm
    close #ff
    color 0,15
    locate 8,52  :print usbcomm
    color 15
    zz2=0 :zz3=0 :zz4=0
    testcla:
    color 15,0
    l=inkey$
    if l="" then goto testmouse
    if asc(l,1)=27 then goto quitsetport
    if asc(l,2)=62 then goto saveexit
    l=left$(l,1)
    if asc(l)>48 and asc(l)<58  then
        usbcomm=val(l)
        locate 8,52 :color 0,15 :print usbcomm
    end if
    testmouse:
    getmouse x,y,wheel,bouton
    if x>(ali)*8 and x<(ali+12)*8 and y>(44*16) and  y<=(45*16)   then 
        if zz5=0 then
            locate 45,ali+1 :color 0,1 :print "Exit (ESC)"
            zz5=1 :color 15,0
        end if
    else
        if zz5=1 then
            locate 45,ali+1 :color 1,0 :print "Exit (ESC)"
            zz5=0 :color 15
        end if
    end if
    if x>(ali+51)*8 and x<(ali+70)*8 and y>(44*16) and  y<=(45*16)   then  
        if zz7=0 then
            locate 45,ali+52 :color 0,1 :print "Save and Exit (F4)"
            zz7=1 :color 15,0
        end if
    else
        if zz7=1 then
            locate 45,ali+52 :color 1,0 :print "Save and Exit (F4)"
            zz7=0 :color 15
        end if
    end if    
    if zz5=1 then                     'exit
        if bouton=1 and cleft=0 then
            goto quitsetport
            cleft=1 :zz5=0 
        end if
        if bouton=2 and cright=0 then
            goto quitsetport
            cright=1 :zz5=0 
        end if    
        if bouton=0 then
            cleft=0 :cright=0
        end if
    end if
    if zz7=1 then                     'save and exit
        if bouton=1 and cleft=0 then
            goto saveexit
            cleft=1 :zz7=0
        end if
        if bouton=2 and cright=0 then
            goto saveexit
            cright=1 :zz7=0
        end if    
        if bouton=0 then
            cleft=0 :cright=0
        end if
    end if
    sleep 3
    goto testcla
    saveexit:
    bobo="configu"
    ff=freefile
    open bobo for binary as #ff
    put #ff,1,usbcomm
    close #ff
    usbcom=usbcomm
    quitsetport:
end sub

deparr:

cursor1=100 :cursor2=200
curseur1=cursor1*(nb-1)/largeur
curseur2=cursor2*(nb-1)/largeur
miin(0)=0 :miin(1)=0 :miin(2)=0 :miin(3)=0 :miin(4)=-100
miin(5)=0 :miin(6)=0 :miin(7)=0 :miin(8)=0 :miin(9)=0
maax(0)=100 :maax(1)=100 :maax(2)=100 :maax(3)=100 :maax(4)=0
maax(5)=100 :maax(6)=100 :maax(7)=100 :maax(8)=100 :maax(9)=1
maxa(0)=225 :maxa(1)=100 :maxa(2)=100 :maxa(3)=100 :maxa(4)=225
maxa(5)=100 :maxa(6)=100 :maxa(7)=100 :maxa(8)=100 :maxa(9)=225
mina(0)=-225 :mina(1)=-100 :mina(2)=0 :mina(3)=0 :mina(4)=-225
mina(5)=0 :mina(6)=0 :mina(7)=0 :mina(8)=0 :mina(9)=-225
miin(10)=1 :maax(10)=100 :maxa(10)=225 :mina(10)=-225

cls
ss11s22=1
color 14
locate 6,8
print "      A Network Analyzer Program    "
locate 8,8
print "            to display "
locate 10,8
print "  Z, R, L, C, S11, S22  measurements."
locate 20,8  :color 6
print "   Choose the file to be displayed"

locate 46,8 :color 1 :print " Exit (Esc) "


color 15

depare:

n=0 :d=0
dlist(d)=dir$("*.s*p")
if dlist(0)="" then
    locate 26,8 :color 0,6
    print " In the current directory there is no file "
    locate 27,8
    print " with the s1p or s2p extension             "
    locate 29,8 :color 0,15
    tournons:
    l=inkey$
    sleep 15
    if l="" then goto tournons
    if asc(l,1)=27 then goto sortie    
    goto tournons
end if
do while dlist(d) <> ""
    d=d+1
    dlist(d)=dir$
loop
d=d-1
j=d 'nb total de fichiers
h=0
pagelength=44
nbofline=j
if j>pagelength then
    nbofline=pagelength
    line (450,20)-(465,740),15,b
    line (450,20)-(465,32),16,bf
    line (450,32)-(465,32),8
    line (465,20)-(465,32),8
    line (451,31)-(464,31),9
    line (464,21)-(464,31),9
    line (450,20)-(450,31),15
    line (450,20)-(464,20),15
    pset (457,24),0
    line (456,25)-(458,25),0
    line (455,26)-(459,26),0
    line (454,27)-(460,27),0
    line (450,728)-(465,740),16,bf
    line (450,740)-(465,740),8
    line (465,728)-(465,740),8
    line (451,739)-(464,739),9
    line (464,729)-(464,739),9
    line (450,728)-(450,739),15
    line (450,728)-(464,728),15
    pset (457,736),0
    line (456,735)-(458,735),0
    line (455,734)-(459,734),0
    line (454,733)-(460,733),0
    bouge=1
    yclic=0
end if
for i=0 to nbofline
    locate 2+i,63
    print dlist(h+i)
next i
setmouse 10,10,1
sleep 30
yy=1 :yysaved=1
getmouse x,y,wheel,bouton
if x>0 and x<1024 and y>0 and y<767 then
    roue=wheel
end if
tournon2:
getmouse x,y,wheel,bouton
if wheel>roue and x>0 and x<1024 and y>0 and y<767 then
    if (j-pagelength)>h then
        h=h+1
        for i=0 to nbofline
            locate 2+i,63
            print "                                             "
            locate 2+i,63
            print dlist(h+i)
        next i
'        locate 1+yy,63 :color 0,15
'        print dlist(h+yy-1)
        color 15,0 :bouge=1
    end if
end if
if wheel<roue and x>0 and x<1024 and y>0 and y<767 then
    if h>0 then 
        h=h-1
        for i=0 to nbofline
            locate 2+i,63
            print "                                             "
            locate 2+i,63            
            print dlist(h+i)
        next i
        color 15,0 :bouge=1
    end if
end if
l=inkey$
if asc(l,1)=27 then goto sortie
if x>7*8 and x<(19)*8 and y>(45*16) and  y<=(46*16)   then 
    if zzz5=0 then
        locate 46,8 :color 0,1 :print " Exit (Esc) "
        zzz5=1 :color 15,0
    end if
else
    if zzz5=1 then
        locate 46,8 :color 1,0 :print " Exit (Esc) "
        zzz5=0 :color 15
    end if
end if
if zzz5=1 then                     'exit
    if bouton=1 and cleft=0 then
        goto sortie
        cleft=1 :zzz5=0 
    end if
    if bouton=2 and cright=0 then
        goto sortie
        cright=1 :zzz5=0 
    end if    
    if bouton=0 then
        cleft=0 :cright=0
    end if
end if

if x>(60*8) and x<(110*8) and y>16 and y<(32+(nbofline*16)) and yclic=0 then
    selectarea=1
    yy=(y-16)\16 +1
    if yysaved<>yy  then
        locate 1+yy,63 :color 0,15
        print dlist(h+yy-1)
        if yysaved>0 then
            locate 1+yysaved,63 :color 15,0
            print dlist(h+yysaved-1)
        end if
        yysaved=yy :color 15,0 :bouge=1
    end if
    if bouge=1 then
        locate 1+yy,63 :color 0,15
        print dlist(h+yy-1)
        color 15,0
    end if
    if bouton=1 then
        bouton=0
        goto vlam
    end if
else
    if selectarea=1 and yclic=0 then
        selectarea=0 :yysaved=0
        for i=0 to nbofline
            locate 2+i,63
            print "                                             "
            locate 2+i,63            
            print dlist(h+i)
        next i
    end if
end if
if x>449 and x<466 and y>19 and y<33 then
    if bouton=1  then
        if h>0 then 
            h=h-1
            for i=0 to nbofline
                locate 2+i,63
                print "                                             "
                locate 2+i,63            
                print dlist(h+i)
            next i
            sleep 300
            bouge=1
        end if
    end if
end if
if x>449 and x<466 and y>727 and y<741 then
    if bouton=1 then
        if (j-pagelength)>h then
            h=h+1
            for i=0 to nbofline
                locate 2+i,63
                print "                                             "
                locate 2+i,63
                print dlist(h+i)
            next i
            sleep 300
            bouge=1
        end if
    end if
end if
if j>pagelength then
    curhaut=((727-33)*h\j)+33
    curbas=((727-33)*h\j+((727-33)*pagelength\j))+33
end if    
if x>449 and x<466 and y>=curhaut and y<=curbas and yclic=0 and bouton=1 then
    yclic=y :hclic=h
end if
if bouton=0 then yclic=0
if yclic>0 and y<>yclic then
    newh=hclic+(j*(y-yclic)\(727-33))
'    locate 46,80 :print "newh=";newh,"h=";h
    if newh<0 then newh=0
    if newh>j-pagelength then newh=j-pagelength
    if newh<>h then
        h=newh :bouge=1
        for i=0 to nbofline
            locate 2+i,63
            print "                                             "
            locate 2+i,63
            print dlist(h+i)
        next i
    end if
end if
if j>pagelength then
    curhaut=((727-33)*h\j)+33
    curbas=((727-33)*h\j+((727-33)*pagelength\j))+33
end if   
if  x>0 and x<1024 and y>0 and y<767 then
    roue=wheel
end if
if j>pagelength and bouge=1 then
    line(451,33)-(464,curhaut),0,bf
    line(451,curbas)-(464,727),0,bf
    line(450,33)-(450,727),15
    line(465,33)-(465,727),15
    line(451,curhaut)-(464,curbas),16,bf    
    line(450,curbas)-(465,curbas),8
    line(465,curhaut)-(465,curbas),8
    line(464,curhaut+1)-(464,curbas-1),9
    line(451,curbas-1)-(464,curbas-1),9
    line(450,curhaut)-(450,curbas-1),15
    line(450,curhaut)-(464,curhaut),15
end if
bouge=0
sleep 15
goto tournon2

vlam:

bibi=dlist(h+yy-1)

cls
sxp=1 ' =1 si fichier s1p , =2 si fichier s2p
if right(bibi,3) = "s2p" or right(bibi,3) = "S2P" then 
 sxp=2 
end if

sorre:

'd%=0 :n%=0 :h%=0 :f%=0
'b%=3 'distance en haut et a gauche entre la courbe et le bord de l'ecran
''ti%=0 'choix de:  dB & phase linear sweep
'ti%=0 'choix de impedance vs frequency z & arg(z)
'ti%=1  choix de impedance vs frequency Re(z) & Im(z)
'ti%=2  capacitance vs frequency C(pf) & Q
'ti%=3  inductance vs frequency L(nH) & Q
'ti%=4  s11 vs frequency  s11(dB) arg(s11) deg
'ti%=5  capacitance vs frequency C(pf) & Q , parallele configuration
'ti%=6  inductance vs frequency L(nH) & Q , parallele configuration
'ti%=7  capacitance vs frequency C(pf) & R parallele
'ti%=8  inductance vs frequency L(nH) & R parallele
'ti%=9  s11 vs frequency s11(U) arg(s11) deg
'ti%=10 impedance vs frequency |z| log scale


cls

'lecture du fichier s1p ou s2p

c="" 'caractere lut dans le fichier s1p
esclam=0 'esclam%=1 si on a lut un "!" en debut de ligne
diese=0  'diese%=1  on  lit la ligne du "#" 
          'diese%=2 (ou plus) = on a deja lut la ligne du diese 
done = 0 'on n'a pas encore ecrit la frquence    
'done% = 1 'on ecrit la frequence
'done% = 2 'on a fini d'ecrire la frequence
'done% = 3 'on ecrit le module de s11 en dB
'done% = 4 'on a fini d'ecrire le module de s11
'done% = 5 'on ecrit la phase de s11
'done% = 6 'on a fini d'ecrire la phase de s11
'done% = 7 'on ecrit le module de s21
'done% = 8 'on a fini d'ecrire le module de s21
'done% = 9 'on ecrit la phase de s21
'done% = 10 'on a fini d'ecrire la phase de s21
'done% = 11 'on ecrit le module de s12
'done% = 12 'on a fini d'ecrire le module de s12
'done% = 13 'on ecrit la phase de s12
'done% = 14 'on a fini d'ecrire la phase de s12
'done% = 15 'on ecrit le module de s22
'done% = 16 'on a fini d'ecrire le module de s22
'done% = 17 'on ecrit la phase de s22
'done% = 18 'on a fini d'ecrire la phase de s22
nbb=0 'numero de la frequence 
freqqs="" 'pour ecrire la frequence
ms11s=""  'pour ecrire le module de s11
as11s=""  'pour ecrire la phase de s11 
ms22s=""  'pour ecrire le module de s22
as22s=""  'pour ecrire la phase de s22

ff=freefile
open bibi for binary as #ff 
taille = lof(ff)

seek #ff,0

bcl1:      'boucle de lecture du fichier 
if taille = loc(ff) then
    if nbb<200 then goto erreur
    goto finlec
end if
c=" "
get #ff, ,c
if esclam=1 then
 if c=chr$(10) then esclam=0 
 goto bcl1
end if
if diese=1 then 'mettre ici la lecture des formats
 if c=chr$(10) then diese=2 
 goto bcl1
end if
if c="!" then esclam=1
if c="#" then diese=diese + 1
if c=" " then
 if done = 1 then
  done = 2
  freqq(nbb) = val(freqqs)
  freqqs = ""
 end if
 if done = 3 then
  done = 4
  ms11(nbb) = val(ms11s)
  ms11s = ""
 end if
 if done = 5 then
  done = 6
  as11(nbb) = val(as11s)
  as11s=""
 end if
 if done=7 then done=8
 if done=9 then done=10
 if done=11 then done=12
 if done=13 then done=14
 if done=15 then
  done=16 : ms22(nbb) = val(ms22s) : ms22s=""
 end if
 if done=17 then
  done=18 : as22(nbb) = val(as22s) : as22s=""
 end if
end if
if (asc(c)>42 and asc(c)<58 and not(asc(c)=47)) or c="E" or c="e" then
 if diese = 0  or diese > 2 then goto erreur
 if done mod 2 = 0 then done= done + 1
 if done = 1 then freqqs = freqqs + c
 if done = 3 then ms11s = ms11s + c
 if done = 5 then as11s = as11s + c
 if done = 15 then ms22s = ms22s + c
 if done = 17 then as22s = as22s + c
end if
if c=chr$(10) then
 if done > 0 and done < 5 then goto erreur
 if done = 5 and sxp=1 then
  done = 0
  as11(nbb) = val(as11s)
  as11s=""
 end if
 if done = 17 and sxp=2 then
  done = 0
  as22(nbb) = val(as22s)
  as22s=""
 end if
 if done = 6 and sxp = 1 then done=0
 if done = 18 and sxp=2 then done=0
' if nbb < 400 then
  nbb = nbb + 1
'  else
'  goto finlec
' end if
end if
goto bcl1

erreur:
locate 5,5
print " error : the file is not compatible  "
locate 7,5
print " Wait "
sleep 3000
goto deparr

finlec:
nb=nbb
curseur1=cursor1*(nb-1)/largeur
curseur2=cursor2*(nb-1)/largeur
close #ff
'fstop=freqq(400)
fstop=freqq(nb-1)
fstart=freqq(0)
span=fstop-fstart
center=(fstart+fstop)/2
ss11s22=1 'on choisit l'entre par defaut

for i= 0 to (nb-1)
mods11=10^((ms11(i))/20)   'calcul du module de s11
angls11=(as11(i))*pi/180   'calcul de la phase de s11 en radians
rs11 = mods11 * cos(angls11) 'calcul de la partie reelle de s11
is11 = mods11 * sin(angls11) 'calcul de la partie imaginaire de s11 
denomina=1-2*rs11+rs11^2+is11^2
if denomina=0 then denomina=1E-46
w33(i)=50*(1-rs11^2-is11^2)/denomina 'calcul de la partie reelle de l'impedance
z33(i)=100*is11/denomina              'calcul de la partie imaginaire de l'impedance
next i

if sxp=2 then
 for i= 0 to (nb-1)
 mods22=10^((ms22(i))/20)   'calcul du module de s11
 angls22=(as22(i))*pi/180   'calcul de la phase de s11 en radians
 rs22 = mods22 * cos(angls22) 'calcul de la partie reelle de s22
 is22 = mods22 * sin(angls22) 'calcul de la partie imaginaire de s22 
 denomina=1-2*rs22+rs22^2+is22^2
 if denomina=0 then denomina=1E-46
 M1(i)=50*(1-rs22^2-is22^2)/denomina 'calcul de la partie reelle de l'impedance
 M2(i)=100*is22/denomina              'calcul de la partie imaginaire de l'impedance
 next i
end if

' on determine si le balayage est lineaire ou logarithmique

'flin200=((fstop-fstart)*200/(nb-1)+fstart)
'flog200=10^((log(fstop/fstart)/log(10))*200/(nb-1))*fstart
flin200=((fstop-fstart)/2+fstart)
flog200=10^((log(fstop/fstart)/log(10))*1/2)*fstart
if abs(flin200 -freqq((nb-1)/2)) < abs(flog200-freqq((nb-1)/2)) then
    linlog=0
else
    linlog=1
end if
va=0 :ti=0 :complet=1
for p=0 to nb-1
if linlog=1 then
    freq(p)=10^((log(fstop/fstart)/log(10))*p/(nb-1))*fstart
else
    freq(p)=(fstop-fstart)*p/(nb-1)+fstart
end if
next p
for p=0 to nb-1
    calcul()
    next p
    screencopy 2,1
    menu()
    dessin1()
    markers()
    dessin2()
    resetz()
    p=0 :refresh=0
goto boucle

menu()
dessin1()
markers()
dessin2()


f=FreeFile

color 15,0

parici:
parla:

getmouse x,y,wheel,bouton

color 15

l=inkey$
if l=" " or stoprequest=1 then
    va=0 :stoprequest=0
    if (cal=2 or cal=4 or cal=6) then
        cal=0
        locate 20,20 :color 0,15 :print " Calibration aborted "
        sleep 2000 :color 15,0
    end if
    menu()
    dessin1()
    markers()
    dessin2()
    refresh=0 :z1=0 :z2=0 :z3=0 :z4=0 :z5=0 :z6=0 :z7=0 :z8=0 :z9=0 :z10=0 :z11=0
    z12=0 :z13=0 :z14=0 :z15=0 :z16=0 :z17=0 :z18=0
    z22=0 :z23=0 :z24=0 :z25=0 :zq22=0
    goto boucle
end if
if l="" then goto pluloin
if asc(l,1)=27 then goto sortie

pluloin:

calcul()
screencopy 2,1
markers()
dessin2()
pmax=p
p=p+1 
if p=nb then
    p=0 :complet=1
end if

goto parla


boucle:


getmouse x,y,wheel,bouton
color 15

if z1=1 then                     'change the main choice
    if bouton=1 and cleft=0 then
        ti=ti+1 :if ti=11 then ti=0
        cleft=1 :z1=0 :refresh=1
    end if
    if bouton=2 and cright=0 then
        ti=ti-1 :if ti=-1 then ti=10
        cright=1 :z1=0 :refresh=1
    end if    
    if bouton=0 then
        cleft=0 :cright=0
    end if
    if wheel>roue1 and y>8 then
       ti=ti+1 :if ti=11 then ti=0
       z1=0 :refresh=1 :sleep 100 :roue1=wheel
    end if
    if wheel<roue1 and y>8 then
        ti=ti-1 :if ti=-1 then ti=10
        z1=0 :refresh=1 :sleep 100 :roue1=wheel
    end if
else
    roue1=wheel
end if
if y<8 then roue1=wheel
if z2=1 then   'pour editer gain max                      
    if (bouton=1 and cleft=0) then
        locate 6,rep+12 :color 0,14
        print "_             "
        color 15,0
        z2sub() :verif()
        if sort=1 then goto sortie
        cleft=1 :z2=0 :refresh=1
    end if
    if bouton=0 then cleft=0
    if wheel<roue2 or wheel>roue2 then
        wheel1()
        if wheel<roue2 then kz=-kz
        if maax(ti)+kz<9999999999.98 and maax(ti)+kz>-999999999.99 and maax(ti)+kz>miin(ti) then
            maax(ti)=maax(ti)+kz
            sleep 100
            z2=0 :refresh=1
        end if
        roue2=wheel
    end if
else
    roue2=wheel
end if
if z3=1 then   'pour editer gain min                      
    if (bouton=1 and cleft=0) then
        locate 7,rep+12 :color 0,14
        print "_            "
        color 15,0
        z2sub() :verif()
        if sort=1 then goto sortie
        cleft=1 :z3=0 :refresh=1
    end if
    if bouton=0 then cleft=0
    if wheel<roue3 or wheel>roue3 then
        wheel1()
        if wheel<roue3 then kz=-kz
        if miin(ti)+kz<9999999999.98 and miin(ti)+kz>-999999999.99 and miin(ti)+kz<maax(ti) and ti<10 then
            miin(ti)=miin(ti)+kz
            sleep 100
            z3=0 :refresh=1
        end if
        if miin(ti)+kz<9999999999.98 and miin(ti)+kz>0.0008 and miin(ti)+kz<maax(ti) and ti=10 then
            miin(ti)=miin(ti)+kz
            sleep 100
            z3=0 :refresh=1
        end if        
        roue3=wheel
    end if
else
    roue3=wheel   
end if
if z4=1 then 'pour editer phase (delay) max
    if (bouton=1 and cleft=0) then
        locate 10,rep+12 :color 0,14
        print "_            "
        color 15,0
        z4sub() :verif()
        if sort=1 then goto sortie
        cleft=1 :z4=0 :refresh=1
    end if
    if bouton=0 then cleft=0
    if wheel<roue4 or wheel>roue4 then
        wheel1()
        if wheel<roue4 then kz=-kz
        if maxa(ti)+kz<9999999999.98 and maxa(ti)+kz>-999999999.99 and maxa(ti)+kz >mina(ti) then
            maxa(ti)=maxa(ti)+kz
            sleep 100
            z4=0 :refresh=1
        end if
        roue4=wheel
    end if
else
    roue4=wheel   
end if
if z5=1 then 'pour editer phase (delay) min
    if (bouton=1 and cleft=0) then
        locate 11,rep+12 :color 0,14
        print "_            "
        color 15,0
        z4sub() :verif()
        if sort=1 then goto sortie
        cleft=1 :z5=0 :refresh=1
    end if
    if bouton=0 then cleft=0
    if wheel<roue5 or wheel>roue5 then
        wheel1()
        if wheel<roue5 then kz=-kz
        if mina(ti)+kz<9999999999.98 and mina(ti)+kz>-999999999.99 and mina(ti)+kz<maxa(ti) then
            mina(ti)=mina(ti)+kz
            sleep 100
            z5=0 :refresh=1
        end if
        roue5=wheel
    end if
else
    roue5=wheel   
end if
if z14=1 and sxp=2 then 'parameter
    if (bouton=1 and cleft=0) then
        ss11s22=ss11s22+1
        if ss11s22=4 then ss11s22=1
        if sxp=1 then ss11s22=1
        cleft=1 :z14=1 :refresh=1
    end if
    if bouton=0 then cleft=0
    if (bouton=2 and cright=0) then
        ss11s22=ss11s22-1
        if ss11s22=0 then ss11s22=3
        if sxp=1 then ss11s22=1
        cright=1 :z14=1 :refresh=1
    end if
    if bouton=0 then
        cleft=0 :cright=0
    end if
end if

if z15=1 then                    'display
    if bouton=1 and cleft=0 then
        if dis=0 then
            dis=1
        else
            dis=0
        end if
        cleft=1 :z15=0 :refresh=1
    end if
    if bouton=2 and cright=0 then
        if dis=0 then
            dis=1
        else
            dis=0
        end if
        cright=1 :z15=0 :refresh=1      
    end if    
    if bouton=0 then cleft=0 :cright=0
end if

if z17=1 then
    if bouton=1 and cleft=0 then
        if complet=1 then
            savefile() 
            menu() :dessin1() :markers :dessin2() :verif
            if bmpecri=1 then
                bmpecri=0 :ecribmp()
            end if
        end if
        cleft=1 :z17=0
    end if
    if bouton=0 then cleft=0
end if

if z23=1 then                     'to display the help message
    if bouton=1 and cleft=0 then
        help()
        menu() :dessin1()
        markers() :dessin2() :verif()
        cleft=1 :z23=0 ':refresh=1
    end if
    if bouton=2 and cright=0 then
        help()
        menu() :dessin1()
        markers() :dessin2() :verif()
        cright=1 :z23=0 ':refresh=1
    end if    
    if bouton=0 then
        cleft=0 :cright=0
    end if
end if

if z24=1 then 'file access
    if bouton=0 then
        cleft=0 :cright=0
    end if
    if bouton=1 and cleft=0 then
        z24=0 :goto deparr
    end if
    if bouton=2 and cright=0 then
        z24=0 :goto deparr
    end if
end if

if z25=1 then 'pour sortir
    if bouton=1 and cleft=0 then
        goto sortie
    end if
    if bouton=2 and cright=0 then
        goto sortie
    end if
    if bouton=0 then
        cleft=0 :cright=0
    end if
    
end if

'pour deplacer les curseurs sur la courbe

if x>bor+cursor1-7 and x<bor+cursor1+7 and y>bor-1 and y<bor+hauteur+1 and cur2=0 then
    if cur1=0 and cur2=0 then
        cur1=1
    end if
else
    if cur1=1 and bouton=0 then
        cur1=0
    end if
end if
if cur1=1 and bouton=1 and x<>bor+cursor1 and x<bor+largeur+1 and x>bor-1 then
    xx=x
    if xx>bor+largeur then xx=bor+largeur
    if xx<bor then xx=bor
    cursor1=xx-bor
    curseur1=cursor1*(nb-1)/largeur
    screencopy 2,1
    markers()
    dessin2()
end if

if x>bor+cursor2-7 and x<bor+cursor2+7 and y>bor-1 and y<bor+hauteur+1 and cur1=0 then
    if cur1=0 and cur2=0 then
        cur2=1
    end if
else
    if cur2=1 and bouton=0 then
        cur2=0
    end if
end if
if cur2=1 and bouton=1 and x<>bor+cursor2 and x<bor+largeur+1 and x>bor-1 then
    xx=x
    if xx>bor+largeur then xx=bor+largeur
    if xx<bor then xx=bor
    cursor2=xx-bor
    curseur2=cursor2*(nb-1)/largeur
    screencopy 2,1
    markers()
    dessin2()
end if


'pour deplacer le pointeur dans les menus
repl=(rep+1)*8
if x>(rep+1)*8 and x<(rep+1)*8+200 and y>=0 and  y<48   then  'main choice
    if z1=0 then
        'color 0,14
        z1=1
        menu() :dessin1() :markers() :dessin2() 
        z1=1
        color 15,0
    end if
else
    if z1=1 then
        'color 14,0
        z1=0
        menu() :dessin1() :markers() :dessin2()
        z1=0
        color 15,0
    end if
end if

if x>repl and x<repl+200 and y>79 and  y<96   then  'gain max
    if z2=0 then
        locate 6,rep+12 :color 0,15
        print using "##########.###";maax(ti)
        'locate 6,rep+25 :print "  "
        z2=1
        color 15,0
        'sleep 2
    end if
else
    if z2=1 then
        locate 6,rep+12 :color 15,0
        print using "##########.###";maax(ti)
        'locate 6,rep+25 :print "  "        
        z2=0
    end if
end if

if x>repl and x<repl+200 and y>95 and  y<112   then  'gain min
    if z3=0 then
        locate 7,rep+12 :color 0,15
        print using "##########.###";miin(ti)
        z3=1
        color 15,0
    end if
else
    if z3=1 then
        locate 7,rep+12 :color 15,0
        print using "##########.###";miin(ti)       
        z3=0
    end if
end if

if x>repl and x<repl+200 and y>143 and  y<160   then  'phase/delay max
    if z4=0 then
        locate 10,rep+12 :color 0,15
        print using "##########.###";maxa(ti)
        z4=1
        color 15,0
    end if
else
    if z4=1 then
        locate 10,rep+12 :color 15,0
        print using "##########.###";maxa(ti)
        z4=0
    end if
end if

if x>repl and x<repl+200 and y>159 and  y<176   then  'phase/delay min
    if z5=0 then
        locate 11,rep+12 :color 0,15
        print using "##########.###";mina(ti)
        z5=1
        color 15,0
    end if
else
    if z5=1 then
        locate 11,rep+12 :color 15,0
        print using "##########.###";mina(ti)
        z5=0
    end if
end if

if x>repl and x<repl+200 and y>367 and  y<384  then  'parameter
    if z14=0 and sxp=2 then
        locate 24,rep+12 :color 0,15
        print "              "
        locate 24,rep+12
        if ss11s22=1 then print " s11 (input)  "
        if ss11s22=2 then print " s22 (output) "
        if ss11s22=3 then print " s11 & s22    "
        z14=1 :color 15,0 
    end if
else
    if z14=1 and sxp=2 then
        locate 24,rep+12 :color 15,0
        print "              "
        locate 24,rep+13
        if ss11s22=1 then
            color 15 :print "s11 (input)  "
        end if
        if ss11s22=2 then
            color 15 :print "s22 (output) "
        end if
        if ss11s22=3 then
            color 14 :print "s11"
            locate 24, rep+17 :color 15
            print "&"
            locate 24,rep+19 :color 1
            print "s22    "
        end if
        z14=0
    end if
end if

if x>repl and x<repl+200 and y>383 and  y<400   then  'display
    if z15=0 then
        z15=1
        menu() :dessin1() :markers() :dessin2()
        z15=1 :color 15,0
    end if
else
    if z15=1 then
        z15=0
        menu() :dessin1() :markers() :dessin2()
        z15=0 :color 15,0
    end if
end if
if x>(rep+2)*8 and x<(rep+25)*8 and y>431 and  y<448   then  'copy to
    if z17=0 then
        locate 28,rep+2 :color 0,15
        print " Copy Screen to File    "
        z17=1
        color 15,0
    end if
else
    if z17=1 then
        locate 28,rep+2 :color 15,0
        print " Copy Screen to File    "
        z17=0
    end if
end if

if x>(rep+2)*8 and x<(rep+20)*8 and y>431+16*10 and y<448+16*10 then
    if z23=0 then
        locate 38,rep+2 :color 0,15
        print " Help           "
        z23=1 :color 15,0
    end if
else
    if z23=1 then
        locate 38,rep+2 :color 15,0
        print " Help           "
        z23=0
    end if
end if
if x>(rep+2)*8 and x<(rep+20)*8 and y>431+16*12 and y<448+16*12 then
    if z24=0 then
        locate 40,rep+2 :color 0,15
        print " File Access    "
        z24=1 :color 15,0
    end if
else
    if z24=1 then
        locate 40,rep+2 :color 15,0
        print " File Access    "
        z24=0
    end if
end if
if x>(rep+2)*8 and x<(rep+20)*8 and y>431+16*14 and y<448+16*14 then
    if z25=0 then
        locate 42,rep+2 :color 0,15
        print " Exit           "
        z25=1 :color 15,0
    end if
else
    if z25=1 then
        locate 42,rep+2 :color 15,0
        print " Exit           "
        z25=0
    end if
end if


zut:
if refresh=1 and va=0 and erreur1=0 and erreur2=0 and erreur3=0 and erreur4=0 and erreur5=0 then 'and newcal=0 then
    for p=0 to nb-1
        calcul()
    next p
    menu()
    dessin1()
    markers()
    dessin2()
    resetz()
    p=0 :refresh=0
end if

l=inkey$
sleep 10
if l="" then goto boucle

if l=" " and erreur1=0 and erreur2=0 and erreur3=0 and erreur4=0 and erreur5=0 then
    if cal=1 then
        cal=2 
        p=0 :pmax=0 :ef=0 :complet=0 :m1m2=0
    end if
    if ef=1 then 
        p=0 :pmax=0 :ef=0 :complet=0 :m1m2=0 :newcal=1
    end if
    va=1 :zq22=0
    p=pmax
    menu() :dessin1()
    markers()
    dessin2()
    goto parici
end if
if asc(l)=27 then goto sortie
l=left$(l,1)
if asc(l)>44 and asc(l)<58 and not(asc(l)=47) then
    if (z2=1 or z3=1) then num=1 :z2sub() :verif()  :refresh=1 :z2=0 :z3=0
    if (z4=1 or z5=1) then num=1  :z4sub() :verif() :refresh=1 :z4=0 :z5=0
    if z14=1 then num=1 :refresh=1 :z14sub() :verif() :z14=0
    if (z6=1 or z7=1 or z8=1 or z9=1) then
        num=1 :refresh=1 :z6sub() :verif() :z6=0 :z7=0 :z8=0 :z9=0
    end if
    
end if

goto boucle

sortie:
close

end
